#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[] = "$Id: skeleton.c,v 1.4 1993/12/21 18:45:32 jtc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "../source/c_parser.y"
/* cmp_parser.y - yacc input for RuleWorks language parser */
/****************************************************************************
**                  
RuleWorks - Rules based application development tool.

Copyright (C) 1999  Compaq Computer Corporation

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or any later 
version. 

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details. 

You should have received a copy of the GNU General Public License along 
with this program; if not, write to the Free Software Foundation, 
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Email: info@ruleworks.co.uk
**                                                                         **
****************************************************************************/


/*
**  FACILITY:
**	RuleWorks compiler
**
**  ABSTRACT:
**	Parse source file.  Yacc processes this file and generates
**	cmp_parser_tab.[ch].
**	Each time yyparse (#defined to rul__cmp_yyparse) is called,
**	a construct is parsed and an abstract syntax tree (AST) is
**	built for the construct.  The AST is passed to the ast subsystem,
**	and this function returns 0 on success (via YYACCEPT) or 1 on
**	failure (via YYABORT).
**
**
**  MODIFIED BY:
**	DEC	Digital Equipment Corporation
**	CPQ	Compaq Compuetr Corporation
**
**  MODIFICATION HISTORY:
**
**	23-Dec-1992	DEC	Initial version
**	30-Mar-1994	DEC	Make yacc compatible: Don't define bogus
**					YYMAXDEPTH, don't use %pure_parser bisonism,
**					define yylex() with 0 parameters
**	16-Feb-1998	DEC	class type changed to rclass
**	01-Dec-1999	CPQ	Release with GPL
*/

#include <common.h>
#include <cmp_comm.h>	/* Ast_Node */
#include <scan.h>	/* defines Token_Type and Token_Value & scanner	*/
#include <ast.h>	/* Abstract syntax tree functions */
#include <mol.h>	/* For making molecules out of terminals */
#include <msg.h>
#include <cmp_msg.h>
#include <ctype.h>		/* For toupper() */

extern void rul__main_set_cur_construct (Ast_Node ast);
static void yyerror (char *msg);
static void set_error (void);
static void clear_error (void);
static Boolean in_error (void);
static char *upcase_in_place (char *str);
static Boolean in_construct (void);
static void set_in_construct (void);
void rul__parser_done_with_construct (void);
static void set_cur_construct (Ast_Node_Type typ, Ast_Node name_ast);
static Ast_Node_Type get_construct_type (void);
static char *construct_type_to_name (Ast_Node_Type con_type);
static char *get_construct_name (void);
static Ast_Node compound_is_a_constant (Ast_Node ast);

/*
 * Declare alloca, since Bison code calls it without declaring it.
 */
void *alloca(size_t);


#define yyparse rul__cmp_yyparse

#ifdef YYPURE
#define yylex(yylvalp)  rul__scan_get_token(yylvalp.tok, &SL_line_number)
#else
#define yylex() rul__scan_get_token(&yylval.tok, &SL_line_number)
#endif

#ifdef YYDEBUG
#define YYERROR_VERBOSE	/* be verbose about diagnosing parsing errors	*/
#define xmalloc malloc	/* where is xmalloc defined/declared? use malloc*/
#endif

/* bison.simple does #if YYDEBUG != 0 */
#ifndef YYDEBUG
#define YYDEBUG 0
#endif


static int	SL_line_number = 1; /* scanner position in the source file */

static Molecule	comp_const_val;	/* To build compile-time compound values */
static long	comp_const_index;

#line 124 "../source/c_parser.y"
typedef union {
  Ast_Node	node;		/* Nonterminals */
  Pred_Type	pred;		/* For predicate nonterminal */
  long		ival;
  Token_Value	tok;		/* Terminals (tokens) */
} YYSTYPE;
#line 129 "y.tab.c"
#define TOK_INTEGER_CONST 257
#define TOK_FLOAT_CONST 258
#define TOK_VARIABLE 259
#define TOK_QUOTED_VAR 260
#define TOK_SYMBOL_CONST 261
#define TOK_QUOTED_SYMBOL 262
#define TOK_OPAQUE_CONST 263
#define TOK_INSTANCE_CONST 264
#define TOK_LPAREN 265
#define TOK_RPAREN 266
#define TOK_LBRACE 267
#define TOK_RBRACE 268
#define TOK_LBRACKET 269
#define TOK_RBRACKET 270
#define TOK_HAT 271
#define TOK_OR 272
#define TOK_AND 273
#define TOK_NOT 274
#define TOK_PLUS 275
#define TOK_MINUS 276
#define TOK_TIMES 277
#define TOK_DIVIDE 278
#define TOK_MODULUS 279
#define UMINUS 280
#define TOK_START_DISJUNCTION 281
#define TOK_END_DISJUNCTION 282
#define TOK_EQUAL 283
#define TOK_EQUAL_EQUAL 284
#define TOK_APPROX_EQUAL 285
#define TOK_NOT_APPROX_EQUAL 286
#define TOK_SAME_TYPE 287
#define TOK_DIFF_TYPE 288
#define TOK_NOT_EQ 289
#define TOK_NOT_EQUAL 290
#define TOK_LESS 291
#define TOK_LESS_EQUAL 292
#define TOK_GREATER 293
#define TOK_GREATER_EQUAL 294
#define TOK_CONTAINS 295
#define TOK_DOES_NOT_CONTAIN 296
#define TOK_LENGTH_LESS_EQUAL 297
#define TOK_LENGTH_NOT_EQUAL 298
#define TOK_LENGTH_LESS 299
#define TOK_LENGTH_EQUAL 300
#define TOK_LENGTH_GREATER_EQUAL 301
#define TOK_LENGTH_GREATER 302
#define TOK_ACCEPT 303
#define TOK_ACCEPT_ATOM 304
#define TOK_ACCEPTLINE_COMPOUND 305
#define TOK_ACCEPTS 306
#define TOK_ACTIVATES 307
#define TOK_ADDSTATE 308
#define TOK_AFTER 309
#define TOK_ALIAS_FOR 310
#define TOK_ANY 311
#define TOK_APPEND 312
#define TOK_ARROW 313
#define TOK_ASCID 314
#define TOK_ASCIZ 315
#define TOK_AT 316
#define TOK_ATOM 317
#define TOK_BIND 318
#define TOK_BY 319
#define TOK_BYTE 320
#define TOK_CALL_INHERITED 321
#define TOK_CATCH 322
#define TOK_CLOSEFILE 323
#define TOK_COMPOUND 324
#define TOK_CONCAT 325
#define TOK_COPY 326
#define TOK_CRLF 327
#define TOK_CS 328
#define TOK_DEBUG 329
#define TOK_DECLARATION_BLOCK 330
#define TOK_DEFAULT 331
#define TOK_DO 332
#define TOK_DOLLAR_LAST 333
#define TOK_DOUBLE_FLOAT 334
#define TOK_EB 335
#define TOK_ELSE 336
#define TOK_END_BLOCK 337
#define TOK_END_GROUP 338
#define TOK_ENTRY_BLOCK 339
#define TOK_EVERY 340
#define TOK_EXTERNAL_ROUTINE 341
#define TOK_FAILURE 342
#define TOK_FILENAME 343
#define TOK_FILL 344
#define TOK_FLOAT 345
#define TOK_FOR_EACH 346
#define TOK_GENATOM 347
#define TOK_GENERIC_METHOD 348
#define TOK_GENINT 349
#define TOK_GET 350
#define TOK_IF 351
#define TOK_IN 352
#define TOK_INHERITS_FROM 353
#define TOK_INSTANCE 354
#define TOK_INTEGER 355
#define TOK_IS_OPEN 356
#define TOK_LENGTH 357
#define TOK_LEX 358
#define TOK_LONG 359
#define TOK_MAKE 360
#define TOK_MAX 361
#define TOK_MEA 362
#define TOK_METHOD 363
#define TOK_MIN 364
#define TOK_MODIFY 365
#define TOK_NTH 366
#define TOK_OBJECT_CLASS 367
#define TOK_OF 368
#define TOK_OFF 369
#define TOK_ON 370
#define TOK_ON_EMPTY 371
#define TOK_ON_ENTRY 372
#define TOK_ON_EVERY 373
#define TOK_ON_EXIT 374
#define TOK_OPAQUE 375
#define TOK_OPENFILE 376
#define TOK_OUT 377
#define TOK_P 378
#define TOK_PATHNAME 379
#define TOK_POINTER 380
#define TOK_POSITION 381
#define TOK_QUIT 382
#define TOK_READ_ONLY 383
#define TOK_READ_WRITE 384
#define TOK_REFERENCE 385
#define TOK_REMOVE_EVERY 386
#define TOK_REMOVE 387
#define TOK_RESTORESTATE 388
#define TOK_RETURN 389
#define TOK_RETURNS 390
#define TOK_RG 391
#define TOK_RJUST 392
#define TOK_RULE 393
#define TOK_RULE_BLOCK 394
#define TOK_RULE_GROUP 395
#define TOK_SAVESTATE 396
#define TOK_SHORT 397
#define TOK_SINGLE_FLOAT 398
#define TOK_SCALAR 399
#define TOK_SPECIALIZE 400
#define TOK_SQL_ATTACH 401
#define TOK_SQL_COMMIT 402
#define TOK_SQL_DELETE 403
#define TOK_SQL_DETACH 404
#define TOK_SQL_FETCH_AS_OBJECT 405
#define TOK_SQL_FETCH_EACH 406
#define TOK_SQL_INSERT 407
#define TOK_SQL_INSERT_FROM_OBJECT 408
#define TOK_SQL_ROLLBACK 409
#define TOK_SQL_START 410
#define TOK_SQL_UPDATE 411
#define TOK_SQL_UPDATE_FROM_OBJECT 412
#define TOK_STARTUP 413
#define TOK_STRATEGY 414
#define TOK_SUBCOMPOUND 415
#define TOK_SUBSYMBOL 416
#define TOK_SUCCESS 417
#define TOK_SYMBOL 418
#define TOK_SYMBOL_LENGTH 419
#define TOK_TABTO 420
#define TOK_THEN 421
#define TOK_TRACE 422
#define TOK_UNSIGNED_BYTE 423
#define TOK_UNSIGNED_LONG 424
#define TOK_UNSIGNED_SHORT 425
#define TOK_USES 426
#define TOK_VALUE 427
#define TOK_WHEN 428
#define TOK_WHILE 429
#define TOK_WM 430
#define TOK_WRITE 431
#define YYERRCODE 256
short yylhs[] = {                                        -1,
  199,    0,    0,  139,  139,  139,  139,  139,  139,  139,
  139,  139,  139,  139,  139,  139,  139,  139,  139,  139,
  200,   47,  201,   53,  114,  114,   54,   54,   54,   54,
   54,    8,  191,  179,  202,   97,   97,  203,   96,  204,
   99,  205,   98,  178,  178,  177,  177,   16,  102,  102,
  118,  118,    7,    7,    7,    5,    5,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    9,   10,   21,   25,   31,   39,
   46,   48,   62,   71,   80,   82,  101,  140,  123,  123,
  123,  123,  143,  144,  145,  148,  158,  159,  187,  197,
  198,  161,  162,  163,  164,  165,  166,  167,  168,  173,
  174,  175,  176,   41,   41,   41,  110,  110,   43,   44,
   45,  126,  126,  160,  170,  172,  172,  171,  171,  171,
  171,  171,  171,  171,  171,  171,  171,  171,  171,  171,
  171,  171,  171,  171,  171,  171,  171,  171,  124,  124,
  150,  150,   29,   29,   29,   29,   29,   29,   29,   29,
   30,   30,   17,   17,  206,   26,   51,   32,   32,   32,
   32,   52,   52,  113,  113,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,    1,    2,
  103,  103,   33,   35,   40,   59,   60,   64,   65,   70,
   74,   76,   77,   81,   89,   93,  137,  151,  181,  182,
  183,  184,  186,  207,  153,  125,  125,  154,  154,  180,
  180,  208,   49,  155,   50,  209,   94,  122,  122,  104,
  104,   18,   20,  109,  109,  112,  112,  112,  112,  112,
  112,  112,  111,  111,  105,  105,   19,   19,   19,  210,
   68,   66,   67,   67,   69,  211,   84,   83,   88,   85,
  119,  119,   86,   86,   87,  120,  212,   55,  115,  115,
   56,   56,   56,   11,    3,  149,   57,  116,  116,   58,
  130,  130,  129,  129,  135,  135,  135,  135,  135,  135,
  135,  135,  135,  135,  135,  135,  131,  131,  131,  131,
  133,  133,  133,  134,  134,  134,  213,  152,  156,  156,
  107,  107,   27,   27,  136,   92,   28,   28,   28,  117,
  117,   78,   78,  106,  106,   24,   24,   72,   72,   72,
   72,   72,   72,   79,   79,  147,  147,  146,  146,  146,
   14,   14,   14,   14,   14,   14,   14,   15,   15,   15,
   15,   15,   15,   15,   95,   95,  190,  190,  189,  189,
  188,  188,  188,  188,  188,  188,  188,  196,  196,   63,
  193,  193,  127,  127,  128,  128,  192,  192,  194,  194,
  194,  194,  194,  194,  194,  194,  194,  194,   37,   37,
   37,   37,   37,   91,   91,  121,  121,   90,   90,   90,
   90,   90,   42,   42,   42,   42,   13,   13,   13,   38,
   38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
   38,   38,   38,   38,   38,   38,   22,   22,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,  169,  169,  132,  132,  138,  138,  157,
  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
  157,   36,   36,   36,   36,   36,   36,   36,   36,   36,
   36,   36,   36,   34,  108,  108,   75,   61,  195,  142,
  185,  141,  100,   73,
};
short yylen[] = {                                         2,
    0,    4,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    3,    0,    4,    0,    4,    1,    1,    1,    1,
    1,    2,    2,    2,    0,    3,    2,    0,    3,    0,
    3,    0,    3,    3,    4,    1,    1,    2,    0,    1,
    0,    1,    1,    2,    1,    3,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    3,    3,    2,    2,    3,
    1,    3,    5,    5,    3,    3,    4,    2,    0,    1,
    1,    1,    2,    2,    2,    2,    2,    4,    3,    4,
    2,    3,    1,    3,    1,    6,    2,    3,    2,    1,
    2,    3,    3,    2,    2,    1,    0,    1,    1,    1,
    1,    0,    1,    1,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    2,
    4,    1,    1,    1,    3,    3,    3,    3,    3,    3,
    2,    1,    1,    1,    0,    4,    3,    1,    3,    3,
    2,    3,    3,    0,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    0,    2,    2,    2,    1,    2,    2,    2,    1,    4,
    2,    2,    2,    2,    2,    3,    4,    2,    4,    4,
    2,    2,    2,    0,    4,    0,    4,    1,    1,    1,
    1,    0,    3,    2,    2,    0,    5,    0,    4,    0,
    2,    5,    1,    0,    1,    0,    1,    2,    1,    1,
    1,    1,    0,    2,    0,    2,    4,    4,    4,    0,
    5,    5,    0,    4,    4,    0,    5,    5,    5,    2,
    0,    2,    4,    5,    2,    2,    0,    4,    0,    4,
    1,    1,    1,    2,    3,    2,    4,    0,    2,    4,
    0,    1,    0,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    0,    3,    3,    2,
    0,    2,    2,    0,    1,    1,    0,    7,    1,    1,
    0,    2,    1,    1,    1,    2,    4,    4,    1,    0,
    2,    4,    1,    0,    3,    1,    1,    1,    1,    3,
    3,    3,    1,    1,    3,    2,    1,    3,    2,    1,
    1,    3,    3,    3,    3,    3,    2,    1,    1,    1,
    3,    3,    3,    1,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    1,    1,    1,    1,    2,    1,    2,
    1,    2,    0,    1,    0,    2,    1,    3,    1,    1,
    3,    3,    3,    3,    3,    3,    3,    3,    1,    1,
    1,    1,    1,    2,    1,    0,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    2,    2,    2,    4,    0,    2,    1,    1,    1,    1,
    1,    1,    1,    1,
};
short yydefred[] = {                                      0,
    3,    1,    0,    0,   20,    0,   21,  252,    0,    0,
    0,    0,    0,    0,   38,   35,   42,   40,  340,  339,
    0,    0,    0,   19,    4,    7,    9,    5,   13,   12,
   11,   10,   15,   14,   17,   16,    0,   18,    6,    8,
    0,  601,  602,  484,  482,  483,  485,  457,  458,  459,
  486,  529,  530,  487,  488,  489,  490,  491,  531,  492,
  493,  532,  494,  533,  460,  461,  534,  462,  495,  535,
  440,  536,  496,  497,  498,  499,  500,  441,  442,  443,
  463,  444,  501,  564,  502,  464,  537,  465,  445,  466,
  467,  538,  503,  504,  505,  468,  469,  470,  506,  507,
  539,  471,  508,  446,  472,  540,  473,  447,  509,  448,
  449,  451,  452,  511,  541,  510,  453,  565,  512,  474,
  542,  513,  514,  515,  544,  543,  545,  546,  475,  516,
  476,  454,  455,  456,  547,  517,  518,  519,  548,  552,
  553,  554,  555,  557,  556,  558,  559,  560,  561,  562,
  563,  450,  520,  477,  478,  521,  479,  480,  481,  522,
  549,  523,  524,  525,  526,  527,  550,  528,  551,  431,
  439,  428,  429,  430,  185,  438,  432,  437,    0,    0,
  427,  255,   23,  297,  280,  286,  256,    0,    0,    0,
    0,  244,  254,    0,    0,    2,  337,    0,   22,  253,
   25,    0,    0,    0,    0,   55,    0,   53,    0,    0,
    0,    0,  246,   94,    0,    0,    0,    0,    0,    0,
    0,  101,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  123,    0,  125,    0,
    0,    0,    0,  130,    0,    0,    0,    0,    0,  405,
   46,   58,   59,  405,   47,   60,   61,   62,   63,   64,
   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
   75,   76,   77,   78,   82,   83,   84,   85,   86,   87,
   88,   89,   90,   91,   92,   93,    0,   79,   80,   81,
    0,    0,    0,  186,    0,    0,  298,    0,    0,    0,
    0,    0,  260,    0,   57,   54,    0,  597,  598,  599,
  603,  604,    0,  409,  420,  422,  419,  423,  421,   95,
  407,  410,    0,   48,    0,  399,    0,  401,    0,  169,
    0,    0,    0,    0,    0,  169,  173,  174,  169,    0,
  384,    0,  111,  112,  110,  379,  378,  108,  380,  182,
    0,    0,  115,  116,  404,  117,    0,    0,    0,  436,
  433,  434,  435,    0,  136,    0,  140,  600,  161,  162,
  163,  164,  165,  167,  168,  151,  152,  153,  154,  155,
  156,  159,  160,  157,  158,  166,  148,  150,  127,  147,
    0,  149,    0,    0,    0,  129,  131,  143,    0,    0,
  385,  386,    0,    0,    0,    0,   44,    0,  349,    0,
  341,    0,    0,    0,    0,  302,  301,    0,  303,    0,
    0,  281,    0,    0,  287,    0,    0,   56,    0,    0,
    0,    0,  405,  405,  225,    0,    0,    0,  229,    0,
    0,    0,    0,  405,  405,    0,    0,    0,    0,    0,
    0,    0,    0,  196,  197,    0,  371,    0,    0,  198,
  199,    0,  200,  201,  202,    0,  203,  204,  205,  206,
  207,  208,    0,  209,    0,  210,  211,  212,  213,    0,
    0,  214,  215,  216,  217,  218,   96,   97,  398,  402,
    0,  102,    0,    0,    0,    0,  188,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  181,  169,  134,  135,  138,  139,  122,  124,  146,
    0,  128,  132,  133,  387,  397,  392,  391,  394,  395,
  393,  396,  389,    0,  119,    0,  406,   45,  350,    0,
    0,    0,    0,   27,   29,    0,   28,   31,   30,    0,
    0,  312,  304,  306,    0,    0,  291,    0,    0,  291,
    0,    0,    0,    0,    0,  261,    0,  249,  248,  377,
  219,  220,    0,    0,    0,  226,  227,  228,    0,  231,
  232,  233,    0,    0,    0,    0,  238,    0,    0,  241,
  242,  243,  413,    0,    0,    0,    0,    0,  411,  418,
  414,  412,  415,  416,  417,  408,  172,    0,  170,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  191,  187,    0,    0,  572,  573,
  574,  575,  570,  571,  576,  577,  580,  581,  578,  579,
    0,    0,  587,  583,  586,  582,  585,  584,  569,    0,
    0,    0,  175,  176,  180,  177,  178,  179,  107,  383,
  381,  382,    0,    0,  390,    0,    0,    0,    0,  342,
  345,  344,  343,  425,    0,  250,  251,   34,    0,   26,
    0,  305,    0,    0,    0,  300,    0,    0,    0,    0,
    0,    0,    0,    0,  259,    0,  263,  247,  222,    0,
    0,  363,  236,  358,  359,    0,  567,    0,    0,    0,
    0,  374,  375,  376,    0,  183,  184,    0,    0,    0,
    0,  193,    0,  189,  590,  591,    0,  192,  592,  593,
    0,  104,    0,  353,  347,    0,  348,  351,  346,  338,
  424,  309,  335,    0,  336,  324,  323,  326,  317,  322,
  315,  325,  316,  321,  320,  318,  319,    0,    0,  282,
  292,    0,    0,  284,  265,    0,  295,  288,    0,    0,
    0,  293,    0,  230,    0,    0,    0,  237,  239,  240,
    0,    0,    0,    0,    0,    0,    0,  126,    0,  314,
    0,  307,    0,  310,  290,    0,  285,  267,  270,    0,
  269,  271,  272,  296,    0,  294,  275,  362,  360,  361,
  357,    0,    0,  171,    0,    0,  330,  332,  333,  274,
  268,  289,    0,  355,    0,    0,  352,    0,  364,  370,
  328,  329,    0,  276,  367,    0,    0,  369,    0,    0,
  365,  366,  368,    0,    0,    0,    0,  595,  278,  277,
  279,    0,  594,  596,
};
short yydgoto[] = {                                       3,
  454,  455,  416,  251,  208,  170,  293,  545,  252,  253,
  417,  171,  172,  456,  457,  255,  735,  566,  854,  716,
  256,  173,  458,  833,  257,   24,  690,  411,  336,  351,
  258,  641,  460,  865,  461,  669,  314,  174,  259,  463,
  364,  365,  516,  366,  393,  260,   25,  261,   26,   27,
  334,  497,   28,  546,   29,  418,  701,  554,  464,  465,
  315,  262,  263,  467,  468,  299,  422,   30,  557,  469,
  264,  723,  316,  470,  317,  471,  472,  758,  847,  265,
  474,  266,  301,   31,  781,  425,  709,  560,  476,  318,
  695,  692,  477,   32,  403,   33,   34,   35,   36,  319,
  267,  294,  572,  427,  843,  802,  540,  872,  786,  518,
  817,  824,  752,  295,  297,  702,  687,  792,  707,  787,
  182,  303,  348,  491,  307,  397,  571,  406,  704,  551,
  812,  726,  814,  764,  778,  693,  478,  848,   37,  268,
  176,  388,  269,  270,  271,  849,  856,  272,  419,  609,
  479,   38,   39,  567,   40,   41,  671,  273,  274,  808,
  275,  276,  277,  278,  279,  280,  281,  282,  177,  398,
  390,  391,  283,  284,  285,  286,  287,  195,  548,  698,
  482,  483,  484,  485,  178,  486,  288,  533,  534,  535,
  549,  355,  329,  321,  322,  327,  289,  290,    4,  179,
  201,  189,  188,  191,  190,  198,  213,  180,  205,  203,
  204,  202,  292,
};
short yysindex[] = {                                   -178,
    0,    0,    0, 6682,    0, 6275,    0,    0, 6275, 6275,
 6617, 6617, 6617, 6275,    0,    0,    0,    0,    0,    0,
 6275, 6275, -180,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -207,    0,    0,    0,
 6275,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 6275, 6275,
    0,    0,    0,    0,    0,    0,    0, -157, -180, -157,
 -157,    0,    0, 1124, -161,    0,    0, -157,    0,    0,
    0, -158, -134, -118,  -80,    0,  952,    0,  -66, -161,
  -66,  -66,    0,    0, 3381, 3381, 6275,  -43,  -43, 3381,
  -43,    0, 3381,  -43,  -55, 5931,  -43, 3381, -192, 5931,
  -43, 3381, 3381, 3381,  -43, 6446,    0, 6275,    0, 3031,
  -43, 6275,  -43,    0, 3031, 6275,  -43, -112,  -55,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -37,    0,    0,    0,
 1124, -110,  -66,    0,    7, -262,    0,  -13,   32,   -8,
   38,  -48,    0,   41,    0,    0,   43,    0,    0,    0,
    0,    0, 5482,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 6275,    0, 3381,    0,  -43,    0, 3381,    0,
 3381,  -42, 3556, -109,  424,    0,    0,    0,    0, 3381,
    0, 5803,    0,    0,    0,    0,    0,    0,    0,    0,
 5931,  -43,    0,    0,    0,    0, 5931, 6275, 6275,    0,
    0,    0,    0, 6275,    0, 3031,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3031,    0,   44,  -43, 3031,    0,    0,    0, 3031, 3031,
    0,    0, -239,  -16, 3381, 3381,    0,   47,    0, 6275,
    0, -255,  -43, 6275,  -43,    0,    0,   48,    0,  -43,
  -71,    0,  -43, 1281,    0, 6275,   49,    0, -345,   12,
 3381, 3381,    0,    0,    0, 5931, 3381, 3381,    0, 3381,
 3381, 3381, 3381,    0,    0, 3381, 3381, 3381, 3381, 3381,
 3381, 3381, 3381,    0,    0,   71,    0,   56,   58,    0,
    0,   64,    0,    0,    0,   65,    0,    0,    0,    0,
    0,    0,   66,    0,   68,    0,    0,    0,    0,   72,
   75,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -188,    0, 3381,  780, 3731,  -83,    0, 3898, -157,   76,
   77,   78,   88,   89,   91, -188, -188, 3381,  277,   93,
   94,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3031,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  136,    0, -157,    0,    0,    0, -194,
 6275, -256, 6275,    0,    0,   95,    0,    0,    0,  -43,
   96,    0,    0,    0,   96, -158,    0,  -64,  -43,    0,
  -56,  -43,  107,  108, 6275,    0,  116,    0,    0,    0,
    0,    0, 3381, 3381, 3381,    0,    0,    0,  112,    0,
    0,    0, 3381, 3381, -185, 3207,    0, -185, -185,    0,
    0,    0,    0,  -61,  -61,  -61,  -61,  -61,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 6104,    0, -157,
  780, 3381, 3381,  -43,    0,    0,  -43,    0, 5931, 3381,
 3381,    0, 3381, 3381, 3381, 3381, 5931,    0,    0,  -43,
 3381, 3381, 3381,  -43, 3381, 3381, 3381, 3381, 3381,    0,
  -24,    0,    0,    0,    0,    0, 3556, 3556,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3207, 3207,    0,    0,    0,    0,    0,    0,    0, 3906,
 -120, -222,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -188,  119,    0,  -66, -196, -110, -157,    0,
    0,    0,    0,    0, 6275,    0,    0,    0, 6275,    0,
  -43,    0,  -18,  164,  164,    0,  -78,    8,  120,   67,
  -57,   35,  124, -157,    0,   67,    0,    0,    0, 6104,
 5803,    0,    0,    0,    0, 3381,    0, -185, -185,   23,
   23,    0,    0,    0,  123,    0,    0,  -66,  294,  128,
  129,    0,  127,    0,    0,    0, 5657,    0,    0,    0,
 -157,    0, -157,    0,    0, 6275,    0,    0,    0,    0,
    0,    0,    0,  131,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   83,  104,    0,
    0,   67,   39,    0,    0, -232,    0,    0,   46, -157,
  -66,    0, -232,    0,  301,  146,  155,    0,    0,    0,
 -164, 3381,    0,    0,    0,  -66,  -66,    0,  123,    0,
 -339,    0, -329,    0,    0, 6275,    0,    0,    0,   39,
    0,    0,    0,    0, 6275,    0,    0,    0,    0,    0,
    0,  102,  154,    0, 1456, -108,    0,    0,    0,    0,
    0,    0,  160,    0, 1981, 3381,    0, 3381,    0,    0,
    0,    0, -215,    0,    0, 1631, 3206,    0, 4956, 5306,
    0,    0,    0,  103,  163,  165,  168,    0,    0,    0,
    0, 5131,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,  175,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  175,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  176,    0,    0,  177,    0,    0,
    0,  181,    0,    0, -139,    0,    0,    0,  187,  191,
  192,  194,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  196,    0,
    0,    0,  197,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  200,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  201,    0,  204,    0,    0,    0,  206,    0,
    0,    0,    0,    0,    0,    0,  207,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  208,    0,  210,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  214,  217,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  220,    0,  200,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  221,    0,    0,  223,    0,    0,    0,    0,    0,  200,
    0,    0,    0,    0,  224,  225,    0,    0,    0,    0,
    0,    0,  599,    0,  599,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  227,    0,    0,    0,
  197,  229,    0,    0,    0,    0,    0,  197,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  231,    0,    0,    0, 4073,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  235,  237,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  238,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  570,
  538,    0,    0,    0,  538,  181,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  197,  240,  243,    0,    0,    0,    0,    0,
    0,    0,  247,  248,    0, 4081,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  774, 1273, 4248, 2156, 2331, 4423, 3375, 4598, 4773,
 3550, 3725, 4948, 5123, 5298, 6096, 6267, 2506, 2681, 6438,
 6833, 6853, 6873, 6893, 6913, 6933, 6953, 6973, 6993, 2856,
    0,  946, 1118, 5476,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 4256, 4431,    0,    0,    0,    0,    0,    0,    0,    0,
 4606,  249,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  251,    0,    0,  252,    0,    0,  177,    0,
    0,    0,    0,    0,  253,    0,    0,    0,  259,    0,
  570,    0,  219,    0,    0,    0,    0,    0,    0, -234,
    0,    0,    0,  264,    0,  -19,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -98,
  -49,    0,    0,    0, 4781,    0,    0,  266,    0,    0,
    0,    0,  -59,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  547,  267,    0,
    0, -175,  -22,    0,    0,   28,    0,    0,    0,  177,
  268,    0,   25,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 5651, 6608, 6813,  270,  272,    0, 1806,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -141,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  271,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -33,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
  205,    0,  133, -189, -190,  310, -133,    0,    0,    0,
    0,    0,   -2, -316, -199,    0, -173,    0,    0,    0,
    0,  315, -328,    0, -312,    0,    0, -523, -206,    0,
    0, -320,    0,    0,  222,    0, -233, -131, -307,    0,
    0,    0,    0,  -85,    0,    0,    0,    0,    0,    0,
  309,   69,    0,    0,    0,    0,  150,    0,    0,    0,
 -227,    0, -293,    0,    0,    0,    0,    0,    0,  230,
    0, -535,    0,    0, -179,    0,    0,    0,    0, -288,
    0, -286,    0,    0,    0,    0,   13,    0,    0,   -6,
   40,    0,  250,    0,    0,    0,    0,    0,    0,    0,
    0, -650,    0,    0,    0, -225,    0,    0, -130,    0,
 -238, -203,    0,    0,   36, -106,    0,    0,   31, -186,
  413,    0,    0, -299,    0, -303, -210, -160,   42,  183,
    0,    0,    0,    0, -105,    0,    0,  101,    0,    0,
    0,    0,    0,    0,    0, -719,    0,    0,  193,    0,
    0,    0,    0,    0,    0,    0, -552,    0, -282,    0,
    0,    0,    0,    0,    0,  290,    0,    0,    0, -235,
  213,    0,    0,    0,    0,    0,  316,  417,  182,    0,
    0,    0,  275,    0,    0,    0,    0,   80,    0,    0,
  190, -187, -221, -272,  281,  -92,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
#define YYTABLESIZE 7295
short yytable[] = {                                     175,
  459,  346,  181,  183,  389,  462,  387,  187,  184,  185,
  186,  387,  496,  510,  192,  193,  691,  304,  306,  466,
  306,  306,  354,  350,  473,  509,  475,  320,  323,  345,
  480,  264,  328,  727,  197,  331,  506,  525,  760,  507,
  340,  502,  207,  413,  353,  836,  356,  414,  511,  347,
  413,  541,  728,  729,  209,  838,  211,  212,  196,  754,
  498,  409,  519,  341,  308,  309,  310,  607,  542,  755,
  410,  308,  342,  310,  756,  305,  264,    1,  818,  721,
  543,  688,  608,  264,  194,  346,    2,  837,  526,  405,
  264,  341,  308,  309,  310,  527,  524,  839,  206,  528,
  342,  696,  306,  291,  363,  697,  296,  207,  745,  746,
  264,  430,  819,  751,  346,  859,  757,  273,  689,  264,
  264,  820,  821,  273,  273,  855,  258,  415,  860,  273,
  298,  258,  387,  347,  415,  264,  862,  488,  352,  826,
  264,  490,  822,  492,  512,  409,  300,  722,  394,  343,
  513,  529,  508,  530,  410,  531,  395,  387,  542,  522,
  399,  387,  347,  523,  759,  387,  387,  372,  831,  264,
  543,  372,  199,  181,  749,  750,  372,  372,  264,  264,
  310,  459,  646,  264,  302,  823,  462,  780,  647,  648,
  532,  254,  799,  800,  341,  308,  309,  310,  207,  264,
  466,  310,  346,  342,  254,  473,  190,  475,  788,  333,
  324,  480,  190,  683,  430,  310,  373,  537,  537,  337,
  373,  498,  498,  337,  344,  373,  373,  578,  407,  576,
  570,  367,  262,  361,  563,  367,  273,  262,  763,  367,
  310,  742,  264,  273,  573,  264,  264,  647,  648,  577,
  347,  264,  579,  580,  581,  582,  401,  402,  585,  586,
  587,  588,  589,  590,  591,  592,  642,  341,  308,  309,
  310,  412,  574,  575,  851,  852,  342,  730,  731,  732,
  733,  734,  740,  583,  584,  684,  266,  387,  254,  266,
  266,  264,  420,  266,  739,  266,  421,  423,  459,  596,
  597,  598,  424,  462,  426,  610,  428,  429,  521,  493,
  254,  499,  538,  556,  643,  536,  487,  741,  559,  565,
  679,  599,  473,  600,  475,  264,  743,  744,  480,  601,
  602,  603,  254,  604,  264,  264,  593,  605,  498,  254,
  606,  673,  674,  675,  337,  594,  595,  596,  597,  598,
  337,  514,  515,  676,  677,  264,  678,  517,  681,  682,
  700,  783,  719,  708,  703,  672,  346,  346,  346,  346,
  346,  712,  714,  715,  498,  498,  594,  595,  596,  597,
  598,  718,  720,  642,  753,  784,  537,  537,  789,  790,
  785,  801,  796,  804,  805,  537,  537,  748,  264,  648,
  810,  811,  686,  539,  795,  724,  816,  553,  724,  724,
  578,  829,  576,  825,  347,  347,  347,  347,  347,  564,
  830,  254,  813,  844,  853,  573,  868,  797,  869,  337,
  870,  643,  577,  871,  459,  579,  580,  581,  582,  462,
  426,   37,   49,  585,  586,  587,  299,  588,  589,  590,
  591,  592,   39,  466,  574,  575,   36,   43,  473,   41,
  475,  109,  403,  526,  480,  142,   50,  583,  584,   24,
  527,  283,  245,   98,  528,   99,  738,  766,  767,  114,
  768,  306,  113,  769,  832,  137,  145,  141,  334,  121,
  400,  640,  257,  346,  221,  306,  100,  770,  325,  326,
  105,  330,  106,  388,  332,  223,  338,  339,  224,  349,
  338,  326,  234,  235,  194,  357,  118,  120,   32,  346,
  392,  326,  771,  396,   33,  392,  529,  400,  530,   51,
  531,  103,  331,   52,  694,  195,  694,  144,  798,  500,
  356,  347,  680,  772,  544,  360,  794,  306,  724,  724,
  362,  594,  595,  596,  597,  598,  501,  404,  717,  803,
  773,  774,  550,  645,  503,  532,  828,  347,  594,  595,
  596,  597,  598,  346,  713,  594,  595,  596,  597,  598,
  791,  841,  699,  835,  504,  793,  775,  776,  777,  827,
  711,  706,  200,  349,  762,  815,  705,  555,  670,  779,
  306,  736,  481,  520,  547,  210,  408,  489,  640,  505,
  568,    0,  337,  685,  834,  306,  306,  806,  569,  807,
  337,  347,  349,    0,  857,  866,  867,    0,    0,    0,
    0,  338,  489,    0,    0,    0,    0,  338,  874,    0,
    0,    0,    0,    0,    0,    0,  392,  850,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  850,  328,    0,
  858,    0,    0,    0,    0,    0,    0,    0,  850,  490,
    0,  392,    0,    0,  489,  392,    0,    0,    0,  392,
  392,    0,    0,    0,   42,   43,    0,    0,  761,    0,
    0,    0,  761,  552,    0,  552,    0,    0,    0,    0,
  558,    0,    0,  561,    0,    0,    0,    0,    0,    0,
  349,    0,    0,  736,    0,    0,  338,    0,  254,    0,
    0,    0,    0,    0,    0,    0,   47,  431,    0,    0,
   51,    0,    0,    0,   54,   55,    0,   56,   57,    0,
   58,    0,   60,   61,  254,   63,    0,    0,  434,  809,
    0,   69,    0,    0,    0,   73,   74,   75,   76,   77,
    0,    0,    0,    0,    0,   83,    0,   85,    0,    0,
    0,    0,    0,  440,  644,   93,   94,   95,    0,    0,
    0,   99,  100,    0,    0,  103,    0,    0,    0,  446,
    0,  109,    0,    0,    0,    0,    0,    0,  114,    0,
  116,  392,    0,  119,    0,  327,  122,  123,  124,  840,
    0,    0,  327,    0,  130,  327,    0,    0,  842,    0,
  136,  137,  138,    0,    0,    0,    0,    0,    0,    0,
  552,    0,    0,    0,    0,  308,    0,  153,  311,  710,
  156,  451,  710,    0,  160,    0,  162,  163,  164,  165,
  166,  313,  313,  168,  313,    0,    0,  313,    0,    0,
  327,  327,    0,  327,    0,  725,  327,  311,  725,  725,
    0,  313,    0,    0,  349,  349,  349,  349,  349,    0,
  327,    0,    0,  311,  311,    0,  311,    0,  737,  311,
    0,  644,    0,    0,  326,    0,  313,  330,    0,  338,
    0,    0,    0,  311,    0,  327,    0,  338,    0,    0,
  339,    0,  311,  311,  357,  311,    0,  313,  311,    0,
    0,    0,    0,    0,    0,    0,  327,    0,  311,    0,
    0,    0,  311,    0,  313,  313,    0,    0,    0,    0,
    0,    0,    0,  327,  327,    0,    0,    0,    0,  311,
    0,    0,    0,    0,    0,    0,    0,  311,    0,    0,
  313,  313,  313,    0,    0,    0,  311,  311,    0,  327,
  327,  327,    0,    0,    0,    0,    0,    0,  311,    0,
    0,  552,    0,  765,    0,    0,    0,  782,    0,    0,
    0,  782,  311,  311,  311,  311,  311,    0,    0,    0,
  737,  349,    0,    0,    0,    0,    0,    0,  725,  725,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  311,  311,  311,    0,    0,    0,  349,    0,    0,
    0,    0,    0,    0,    0,  341,  308,  309,  310,  403,
   42,   43,  311,  312,  611,    0,    0,    0,    0,    0,
    0,   44,   45,  495,    0,  430,  457,  457,  457,  457,
  457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
  457,  457,  457,  457,  457,  457,    0,    0,    0,    0,
    0,  349,   47,  612,  613,   50,   51,   52,   53,    0,
   54,   55,    0,   56,   57,    0,   58,   59,   60,   61,
  614,   63,   64,  615,  616,  617,  618,   69,   70,   71,
   72,   73,   74,   75,   76,   77,   78,   79,   80,  619,
   82,   83,   84,   85,  620,   87,  621,   89,  622,  623,
   92,   93,   94,   95,  624,  625,  626,   99,  100,  627,
  628,  103,  104,  629,  630,  631,  108,  109,    0,    0,
  110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
  632,  121,  122,  123,  124,  125,  126,  127,  128,  129,
  130,  633,  132,  133,  134,  135,  136,  137,  138,  634,
  140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
  150,  151,  152,  153,  635,  636,  156,  637,  638,  639,
  160,  161,  162,  163,  164,  165,  166,  214,  167,  168,
  169,  379,   42,   43,    0,    0,    0,    0,    0,    0,
  379,  379,  379,  379,  379,    0,    0,    0,  420,  420,
  420,  420,  420,  420,  420,  420,  420,  420,  420,  420,
  420,  420,  420,  420,  420,  420,  420,  420,    0,    0,
    0,    0,    0,    0,   47,    0,    0,    0,   51,  215,
  216,    0,   54,   55,    0,   56,   57,    0,   58,  218,
   60,   61,  219,   63,  220,    0,    0,  221,    0,   69,
  222,   71,  223,   73,   74,   75,   76,   77,   78,   79,
   80,    0,   82,   83,    0,   85,    0,  224,    0,   89,
    0,    0,  225,   93,   94,   95,    0,    0,    0,   99,
  100,  226,    0,  103,  104,    0,  227,    0,  108,  109,
    0,    0,  110,  111,  112,  113,  114,  228,  116,  117,
    0,  119,    0,  229,  122,  123,  124,  230,  231,  232,
  233,    0,  130,    0,  132,  133,  134,  234,  136,  137,
  138,  235,  236,  237,  238,  239,  240,  241,  242,  243,
  244,  245,  246,  247,  152,  153,    0,    0,  156,    0,
    0,    0,  160,  248,  162,  163,  164,  165,  166,  214,
  249,  168,  250,  378,   42,   43,    0,    0,    0,    0,
    0,    0,  378,  378,  378,  378,  378,    0,    0,    0,
  419,  419,  419,  419,  419,  419,  419,  419,  419,  419,
  419,  419,  419,  419,  419,  419,  419,  419,  419,  419,
    0,    0,    0,    0,    0,    0,   47,    0,    0,    0,
   51,  215,  216,    0,   54,   55,    0,   56,   57,  217,
   58,  218,   60,   61,  219,   63,  220,    0,    0,  221,
    0,   69,  222,    0,  223,   73,   74,   75,   76,   77,
    0,    0,    0,    0,    0,   83,    0,   85,    0,  224,
    0,    0,    0,    0,  225,   93,   94,   95,    0,    0,
    0,   99,  100,  226,    0,  103,    0,    0,  227,    0,
    0,  109,    0,    0,    0,    0,    0,    0,  114,  228,
  116,    0,    0,  119,    0,  229,  122,  123,  124,  230,
  231,  232,  233,    0,  130,    0,    0,    0,    0,  234,
  136,  137,  138,  235,  236,  237,  238,  239,  240,  241,
  242,  243,  244,  245,  246,  247,  214,  153,  221,    0,
  156,   42,   43,    0,  160,  248,  162,  163,  164,  165,
  166,    0,  249,  168,  250,  458,  458,  458,  458,  458,
  458,  458,  458,  458,  458,  458,  458,  458,  458,  458,
  458,  458,  458,  458,  458,    0,    0,    0,    0,    0,
    0,    0,    0,   47,    0,    0,    0,   51,  215,  216,
    0,   54,   55,    0,   56,   57,    0,   58,  218,   60,
   61,  219,   63,  220,    0,    0,  221,    0,   69,  222,
    0,  223,   73,   74,   75,   76,   77,    0,    0,    0,
    0,    0,   83,    0,   85,    0,  224,    0,    0,    0,
    0,  225,   93,   94,   95,    0,    0,    0,   99,  100,
  226,    0,  103,    0,    0,  227,    0,    0,  109,    0,
    0,    0,    0,    0,    0,  114,  228,  116,    0,    0,
  119,    0,  229,  122,  123,  124,  230,  231,  232,  233,
  562,  130,    0,    0,    0,    0,  234,  136,  137,  138,
  235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
  245,  246,  247,    0,  153,    0,    0,  156,    0,    0,
    0,  160,  248,  162,  163,  164,  165,  166,    0,  249,
  168,  250,  308,  309,  310,    0,   42,   43,  311,  312,
  313,    0,  845,    0,    0,    0,    0,   44,   45,   46,
    0,    0,    0,    0,    0,    0,  846,    0,  649,  650,
  651,  652,  653,  654,  655,  656,  657,  658,  659,  660,
  661,  662,  663,  664,  665,  666,  667,  668,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,    0,  167,  168,  169,  308,  309,  310,
    0,   42,   43,  311,  312,  313,    0,    0,  861,    0,
    0,    0,   44,   45,   46,    0,    0,    0,    0,    0,
    0,  846,    0,  649,  650,  651,  652,  653,  654,  655,
  656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
  666,  667,  668,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,    0,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  354,  354,  354,    0,  354,  354,  354,  354,
  354,    0,  354,    0,    0,    0,    0,  354,  354,  354,
    0,    0,    0,    0,    0,    0,  354,    0,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,    0,  354,  354,    0,  354,
  354,    0,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,    0,    0,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,    0,  354,  354,  354,  308,  309,  310,
    0,   42,   43,  311,  312,  313,    0,    0,    0,    0,
    0,    0,   44,   45,   46,    0,    0,    0,    0,    0,
    0,  846,    0,  649,  650,  651,  652,  653,  654,  655,
  656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
  666,  667,  668,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,    0,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  405,  405,  405,    0,  405,  405,  405,  405,
  405,  405,    0,    0,    0,    0,    0,  405,  405,  405,
    0,    0,    0,    0,    0,    0,    0,    0,  460,  460,
  460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
  460,  460,  460,  460,  460,  460,  460,  460,  405,  405,
  405,  405,  405,  405,  405,    0,  405,  405,    0,  405,
  405,    0,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,    0,    0,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,    0,  405,  405,  405,  405,  405,  405,
    0,  405,  405,  405,  405,  405,  405,    0,    0,    0,
    0,    0,  405,  405,  405,    0,    0,    0,    0,    0,
    0,    0,    0,  461,  461,  461,  461,  461,  461,  461,
  461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
  461,  461,  461,  405,  405,  405,  405,  405,  405,  405,
    0,  405,  405,    0,  405,  405,    0,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,    0,
    0,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,    0,  405,
  405,  405,  405,  405,  405,    0,  405,  405,  405,  405,
  405,  405,    0,    0,    0,    0,    0,  405,  405,  405,
    0,    0,    0,    0,    0,    0,    0,    0,  471,  471,
  471,  471,  471,  471,  471,  471,  471,  471,  471,  471,
  471,  471,  471,  471,  471,  471,  471,  471,  405,  405,
  405,  405,  405,  405,  405,    0,  405,  405,    0,  405,
  405,    0,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,    0,    0,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,    0,  405,  405,  405,  405,  405,  405,
    0,  405,  405,  405,  405,  405,  405,    0,    0,    0,
    0,    0,  405,  405,  405,    0,    0,    0,    0,    0,
    0,    0,    0,  472,  472,  472,  472,  472,  472,  472,
  472,  472,  472,  472,  472,  472,  472,  472,  472,  472,
  472,  472,  472,  405,  405,  405,  405,  405,  405,  405,
    0,  405,  405,    0,  405,  405,    0,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,    0,
    0,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,    0,  405,
  405,  405,  405,  405,  405,    0,  405,  405,  405,  405,
  405,  405,    0,    0,    0,    0,    0,  405,  405,  405,
    0,    0,    0,    0,    0,    0,    0,    0,  428,  428,
  428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
  428,  428,  428,  428,  428,  428,  428,  428,  405,  405,
  405,  405,  405,  405,  405,    0,  405,  405,    0,  405,
  405,    0,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,    0,    0,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
  405,  405,  405,    0,  405,  405,  405,  308,  309,  310,
  368,   42,   43,  311,  312,    0,    0,    0,    0,    0,
    0,    0,   44,   45,   46,  369,  370,  371,  372,  373,
    0,  374,  375,  376,  377,  378,  379,    0,    0,  380,
  381,  382,  383,  384,  385,    0,    0,    0,    0,    0,
    0,    0,    0,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,  386,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  308,  309,  310,    0,   42,   43,  311,  312,
  313,    0,    0,    0,    0,    0,    0,   44,   45,   46,
    0,    0,    0,    0,    0,    0,    0,  863,    0,  649,
  650,  651,  652,  653,  654,  655,  656,  657,  658,  659,
  660,    0,    0,    0,    0,    0,    0,    0,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,    0,  167,  168,  169,  308,  309,  310,
  225,   42,   43,  311,  312,  313,    0,    0,    0,    0,
    0,    0,   44,   45,   46,    0,    0,  462,  462,  462,
  462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
  462,  462,  462,  462,  462,  462,  462,    0,    0,    0,
    0,    0,    0,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,    0,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  308,  309,  310,  403,   42,   43,  311,  312,
  494,    0,    0,    0,    0,    0,    0,   44,   45,  495,
    0,    0,  465,  465,  465,  465,  465,  465,  465,  465,
  465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
  465,  465,    0,    0,    0,    0,    0,    0,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,    0,  167,  168,  169,  308,  309,  310,
  229,   42,   43,  311,  312,  494,    0,    0,    0,    0,
    0,    0,   44,   45,   46,    0,    0,  466,  466,  466,
  466,  466,  466,  466,  466,  466,  466,  466,  466,  466,
  466,  466,  466,  466,  466,  466,  466,    0,    0,    0,
    0,    0,    0,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,    0,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  308,  309,  310,    0,   42,   43,  311,  312,
  747,    0,    0,    0,    0,    0,    0,   44,   45,   46,
  649,  650,  651,  652,  653,  654,  655,  656,  657,  658,
  659,  660,  661,  662,  663,  664,  665,  666,  667,  668,
    0,    0,    0,    0,    0,    0,    0,    0,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,    0,  167,  168,  169,  566,  566,  566,
    0,  566,  566,  566,  566,  566,    0,    0,    0,    0,
    0,    0,  566,  566,  566,  483,  483,  483,  483,  483,
  483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
  483,  483,  483,  483,  483,    0,    0,    0,    0,    0,
    0,    0,    0,  566,  566,  566,  566,  566,  566,  566,
    0,  566,  566,    0,  566,  566,    0,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,    0,
    0,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
  566,  566,  566,  566,  566,  566,  566,  566,    0,  566,
  566,  566,  588,  588,  588,    0,  588,  588,  588,  588,
  588,    0,    0,    0,    0,    0,    0,  588,  588,  588,
  532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
  532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
    0,    0,    0,    0,    0,    0,    0,    0,  588,  588,
  588,  588,  588,  588,  588,    0,  588,  588,    0,  588,
  588,    0,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,    0,    0,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
  588,  588,  588,    0,  588,  588,  588,  589,  589,  589,
    0,  589,  589,  589,  589,  589,    0,    0,    0,    0,
    0,    0,  589,  589,  589,  534,  534,  534,  534,  534,
  534,  534,  534,  534,  534,  534,  534,  534,  534,  534,
  534,  534,  534,  534,  534,    0,    0,    0,    0,    0,
    0,    0,    0,  589,  589,  589,  589,  589,  589,  589,
    0,  589,  589,    0,  589,  589,    0,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,    0,
    0,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
  589,  589,  589,  589,  589,  589,  589,  589,    0,  589,
  589,  589,  568,  568,  568,    0,  568,  568,  568,  568,
  568,    0,    0,    0,    0,    0,    0,  568,  568,  568,
  463,  463,  463,  463,  463,  463,  463,  463,  463,  463,
  463,  463,  463,  463,  463,  463,  463,  463,  463,  463,
    0,    0,    0,    0,    0,    0,    0,    0,  568,  568,
  568,  568,  568,  568,  568,    0,  568,  568,    0,  568,
  568,    0,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,    0,    0,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
  568,  568,  568,    0,  568,  568,  568,  354,  354,  354,
    0,  354,  354,  354,  354,  354,    0,    0,    0,    0,
    0,    0,  354,  354,  354,  464,  464,  464,  464,  464,
  464,  464,  464,  464,  464,  464,  464,  464,  464,  464,
  464,  464,  464,  464,  464,    0,    0,    0,    0,    0,
    0,    0,    0,  354,  354,  354,  354,  354,  354,  354,
    0,  354,  354,    0,  354,  354,    0,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,    0,
    0,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
  354,  354,  354,  354,  354,  354,  354,  354,    0,  354,
  354,  354,  308,  309,    0,    0,   42,   43,  311,  312,
  864,    0,    0,    0,    0,    0,    0,   44,   45,   46,
  467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
  467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
    0,    0,    0,    0,    0,    0,    0,    0,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,    0,  167,  168,  169,  308,  309,    0,
    0,   42,   43,  311,  312,    0,  873,    0,    0,    0,
    0,    0,   44,   45,   46,  468,  468,  468,  468,  468,
  468,  468,  468,  468,  468,  468,  468,  468,  468,  468,
  468,  468,  468,  468,  468,    0,    0,    0,    0,    0,
    0,    0,    0,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,    0,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  308,  309,    0,    0,   42,   43,  311,  312,
    0,    0,    0,    0,    0,    0,    0,   44,   45,   46,
  469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
  469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
    0,    0,    0,    0,    0,    0,    0,    0,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,    0,  167,  168,  169,  341,  308,  309,
  310,  380,   42,   43,    0,    0,  342,    0,    0,    0,
  380,  380,  380,  380,  380,    0,    0,  430,  410,  410,
  410,  410,  410,  410,  410,  410,  410,  410,  410,  410,
  410,  410,  410,  410,  410,  410,  410,  410,    0,    0,
    0,    0,    0,    0,   47,  431,  432,    0,   51,    0,
    0,    0,   54,   55,    0,   56,   57,    0,   58,    0,
   60,   61,  219,   63,    0,  433,  434,  221,  435,   69,
    0,    0,    0,   73,   74,   75,   76,   77,    0,    0,
    0,  436,    0,   83,    0,   85,  437,    0,  438,    0,
  439,  440,    0,   93,   94,   95,  441,  442,  443,   99,
  100,  226,  444,  103,    0,  445,  227,  446,    0,  109,
    0,    0,    0,    0,    0,    0,  114,    0,  116,    0,
    0,  119,  447,    0,  122,  123,  124,    0,    0,    0,
    0,    0,  130,  448,    0,    0,    0,    0,  136,  137,
  138,  235,    0,    0,    0,    0,  240,    0,    0,    0,
    0,    0,    0,    0,    0,  153,  449,  450,  156,  451,
  452,  453,  160,    0,  162,  163,  164,  165,  166,    0,
    0,  168,  341,  308,  309,  310,  383,   42,   43,    0,
    0,  342,    0,    0,    0,  383,  383,  383,  383,  383,
    0,    0,  430,  413,  413,  413,  413,  413,  413,  413,
  413,  413,  413,  413,  413,  413,  413,  413,  413,  413,
  413,  413,  413,    0,    0,    0,    0,    0,    0,   47,
  431,  432,    0,   51,    0,    0,    0,   54,   55,    0,
   56,   57,    0,   58,    0,   60,   61,  219,   63,    0,
  433,  434,  221,  435,   69,    0,    0,    0,   73,   74,
   75,   76,   77,    0,    0,    0,  436,    0,   83,    0,
   85,  437,    0,  438,    0,  439,  440,    0,   93,   94,
   95,  441,  442,  443,   99,  100,  226,  444,  103,    0,
  445,  227,  446,    0,  109,    0,    0,    0,    0,    0,
    0,  114,    0,  116,    0,    0,  119,  447,    0,  122,
  123,  124,    0,    0,    0,    0,    0,  130,  448,    0,
    0,    0,    0,  136,  137,  138,  235,    0,  341,  308,
  309,  310,    0,   42,   43,    0,    0,  342,    0,    0,
  153,  449,  450,  156,  451,  452,  453,  160,  430,  162,
  163,  164,  165,  166,    0,    0,  168,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   47,  431,  432,    0,   51,
    0,    0,    0,   54,   55,    0,   56,   57,    0,   58,
    0,   60,   61,    0,   63,    0,  433,  434,    0,  435,
   69,    0,    0,    0,   73,   74,   75,   76,   77,    0,
    0,    0,  436,    0,   83,    0,   85,  437,    0,  438,
    0,  439,  440,    0,   93,   94,   95,  441,  442,  443,
   99,  100,    0,  444,  103,    0,  445,    0,  446,    0,
  109,    0,    0,    0,    0,    0,    0,  114,    0,  116,
    0,    0,  119,  447,    0,  122,  123,  124,    0,  310,
    0,   42,   43,  130,  448,  335,    0,    0,    0,  136,
  137,  138,   44,   45,   46,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  153,  449,  450,  156,
  451,  452,  453,  160,    0,  162,  163,  164,  165,  166,
    0,    0,  168,   47,   48,   49,   50,   51,   52,   53,
    0,   54,   55,    0,   56,   57,    0,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,    0,
    0,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
  149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,    0,  167,
  168,  169,  310,    0,   42,   43,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   44,   45,   46,  470,  470,
  470,  470,  470,  470,  470,  470,  470,  470,  470,  470,
  470,  470,  470,  470,  470,  470,  470,  470,    0,    0,
    0,    0,    0,    0,    0,    0,   47,   48,   49,   50,
   51,   52,   53,    0,   54,   55,    0,   56,   57,    0,
   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
  108,  109,    0,    0,  110,  111,  112,  113,  114,  115,
  116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
  136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
  146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,    0,  167,  168,  169,   42,   43,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   44,   45,   46,  539,
  539,  539,  539,  539,  539,  539,  539,  539,  539,  539,
  539,  539,  539,  539,  539,  539,  539,  539,  539,    0,
    0,    0,    0,    0,    0,    0,    0,   47,   48,   49,
   50,   51,   52,   53,    0,   54,   55,    0,   56,   57,
    0,   58,   59,   60,   61,   62,   63,   64,   65,   66,
   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
  107,  108,  109,    0,    0,  110,  111,  112,  113,  114,
  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
  135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
  145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,    0,  167,  168,  169,   42,   43,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   44,   45,   46,
  540,  540,  540,  540,  540,  540,  540,  540,  540,  540,
  540,  540,  540,  540,  540,  540,  540,  540,  540,  540,
    0,    0,    0,    0,    0,    0,    0,    0,   47,   48,
   49,   50,   51,   52,   53,    0,   54,   55,    0,   56,
   57,    0,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,  358,   85,
   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
  106,  107,  108,  109,    0,    0,  110,  111,  112,  113,
  114,  115,  116,  117,  359,  119,  120,  121,  122,  123,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  381,  167,  168,  169,   42,   43,    0,
    0,    0,  381,  381,  381,  381,  381,    0,    0,    0,
  411,  411,  411,  411,  411,  411,  411,  411,  411,  411,
  411,  411,  411,  411,  411,  411,  411,  411,  411,  411,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   47,
    0,    0,    0,   51,    0,    0,    0,   54,   55,    0,
   56,   57,    0,   58,    0,   60,   61,    5,   63,    0,
    0,    0,    0,    0,   69,    0,    0,    0,   73,   74,
   75,   76,   77,    0,    0,    0,    0,    0,   83,    0,
   85,    0,    0,    0,    0,    0,    0,    0,   93,   94,
   95,    0,    0,    0,   99,  100,    0,    0,  103,    0,
    0,    0,    0,    0,  109,    0,    0,    0,    0,    0,
    0,  114,    0,  116,    0,    0,  119,    0,    0,  122,
  123,  124,    0,    6,    0,    0,    0,  130,    0,    0,
    0,    7,    0,  136,  137,  138,    0,    0,    8,    9,
   10,    0,   11,    0,    0,    0,    0,    0,    0,   12,
  153,    0,    0,  156,    0,    0,    0,  160,    0,  162,
  163,  164,  165,  166,   13,    0,  168,    0,   14,    0,
    0,    0,   15,   16,   17,   18,    0,    0,    0,   19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   20,   21,   22,    0,  382,    0,
    0,    0,    0,    0,    0,    0,    0,  382,  382,  382,
  382,  382,    0,    0,   23,  412,  412,  412,  412,  412,
  412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
  412,  412,  412,  412,  412,  473,  473,  473,  473,  473,
  473,  473,  473,  473,  473,  473,  473,  473,  473,  473,
  473,  473,  473,  473,  473,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  476,  476,  476,  476,  476,
  476,  476,  476,  476,  476,  476,  476,  476,  476,  476,
  476,  476,  476,  476,  476,  548,  548,  548,  548,  548,
  548,  548,  548,  548,  548,  548,  548,  548,  548,  548,
  548,  548,  548,  548,  548,  477,  477,  477,  477,  477,
  477,  477,  477,  477,  477,  477,  477,  477,  477,  477,
  477,  477,  477,  477,  477,  478,  478,  478,  478,  478,
  478,  478,  478,  478,  478,  478,  478,  478,  478,  478,
  478,  478,  478,  478,  478,  479,  479,  479,  479,  479,
  479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
  479,  479,  479,  479,  479,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  481,  481,  481,  481,  481,
  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
  481,  481,  481,  481,  481,
};
short yycheck[] = {                                       6,
  313,  229,    9,   10,  240,  313,  240,   14,   11,   12,
   13,  245,  333,  342,   21,   22,  540,  207,  209,  313,
  211,  212,  233,  230,  313,  342,  313,  215,  216,  229,
  313,  266,  220,  586,   41,  223,  336,  277,  689,  339,
  228,  335,  265,  306,  232,  385,  234,  310,  342,  229,
  306,  307,  588,  589,  188,  385,  190,  191,  266,  256,
  333,  256,  366,  256,  257,  258,  259,  256,  414,  266,
  265,  257,  265,  259,  271,  207,  311,  256,  311,  265,
  426,  276,  271,  259,  265,  313,  265,  427,  328,  250,
  266,  256,  257,  258,  259,  335,  400,  427,  256,  339,
  265,  358,  293,  265,  236,  362,  265,  265,  661,  662,
  345,  276,  345,  336,  342,  331,  313,  259,  313,  354,
  355,  354,  355,  265,  266,  845,  266,  390,  344,  271,
  265,  271,  366,  313,  390,  311,  856,  325,  231,  790,
  375,  329,  375,  331,  351,  256,  265,  333,  241,  342,
  357,  391,  340,  393,  265,  395,  242,  391,  414,  395,
  246,  395,  342,  399,  688,  399,  400,  266,  333,  345,
  426,  270,  179,  180,  295,  296,  275,  276,  354,  355,
  259,  494,  266,  418,  265,  418,  494,  266,  272,  273,
  430,  194,  728,  729,  256,  257,  258,  259,  265,  375,
  494,  259,  430,  265,  207,  494,  266,  494,  266,  265,
  217,  494,  272,  513,  276,  259,  266,  405,  406,  226,
  270,  494,  495,  230,  417,  275,  276,  438,  266,  436,
  430,  238,  266,  236,  424,  242,  259,  271,  257,  246,
  259,  266,  418,  266,  432,  265,  266,  272,  273,  437,
  430,  271,  440,  441,  442,  443,  369,  370,  446,  447,
  448,  449,  450,  451,  452,  453,  494,  256,  257,  258,
  259,  265,  433,  434,  383,  384,  265,  594,  595,  596,
  597,  598,  611,  444,  445,  521,  259,  521,  291,  265,
  266,  311,  306,  266,  611,  271,  265,  306,  611,  277,
  278,  279,  265,  611,  353,  493,  266,  265,  265,  352,
  313,  421,  266,  266,  494,  332,  323,  611,  390,  271,
  508,  266,  611,  266,  611,  345,  647,  648,  611,  266,
  266,  266,  335,  266,  354,  355,  266,  266,  611,  342,
  266,  266,  266,  266,  351,  275,  276,  277,  278,  279,
  357,  358,  359,  266,  266,  375,  266,  364,  266,  266,
  266,  354,  573,  428,  269,  499,  594,  595,  596,  597,
  598,  428,  266,  266,  647,  648,  275,  276,  277,  278,
  279,  266,  271,  611,  266,  266,  574,  575,  354,  266,
  324,  269,  721,  266,  266,  583,  584,  670,  418,  273,
  270,  319,  536,  410,  721,  585,  368,  414,  588,  589,
  621,  266,  619,  368,  594,  595,  596,  597,  598,  426,
  266,  424,  319,  270,  265,  613,  324,  721,  266,  436,
  266,  611,  620,  266,  747,  623,  624,  625,  626,  747,
  266,  266,  266,  631,  632,  633,  266,  635,  636,  637,
  638,  639,  266,  747,  615,  616,  266,  266,  747,  266,
  747,  266,  266,  328,  747,  266,  266,  628,  629,  266,
  335,  266,  266,  266,  339,  266,  610,  314,  315,  266,
  317,  672,  266,  320,  801,  266,  266,  265,  270,  266,
  266,  494,  266,  721,  266,  686,  266,  334,  218,  219,
  266,  221,  266,  266,  224,  266,  226,  227,  266,  229,
  230,  231,  266,  266,  266,  235,  266,  266,  266,  747,
  240,  241,  359,  243,  266,  245,  391,  247,  393,  266,
  395,  266,  266,  266,  541,  266,  543,  266,  726,  335,
  270,  721,  266,  380,  412,  236,  720,  738,  728,  729,
  236,  275,  276,  277,  278,  279,  335,  249,  565,  266,
  397,  398,  413,  495,  335,  430,  266,  747,  275,  276,
  277,  278,  279,  801,  562,  275,  276,  277,  278,  279,
  714,  820,  543,  809,  335,  716,  423,  424,  425,  793,
  560,  556,  180,  313,  701,  782,  555,  415,  498,  705,
  791,  608,  313,  391,  412,  189,  291,  327,  611,  335,
  429,   -1,  619,  534,  802,  806,  807,  751,  429,  753,
  627,  801,  342,   -1,  846,  859,  860,   -1,   -1,   -1,
   -1,  351,  352,   -1,   -1,   -1,   -1,  357,  872,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  366,  835,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  845,  846,   -1,
  848,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  856,  857,
   -1,  391,   -1,   -1,  394,  395,   -1,   -1,   -1,  399,
  400,   -1,   -1,   -1,  261,  262,   -1,   -1,  695,   -1,
   -1,   -1,  699,  413,   -1,  415,   -1,   -1,   -1,   -1,
  420,   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,   -1,
  430,   -1,   -1,  720,   -1,   -1,  436,   -1,  721,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,   -1,   -1,
  307,   -1,   -1,   -1,  311,  312,   -1,  314,  315,   -1,
  317,   -1,  319,  320,  747,  322,   -1,   -1,  325,  756,
   -1,  328,   -1,   -1,   -1,  332,  333,  334,  335,  336,
   -1,   -1,   -1,   -1,   -1,  342,   -1,  344,   -1,   -1,
   -1,   -1,   -1,  350,  494,  352,  353,  354,   -1,   -1,
   -1,  358,  359,   -1,   -1,  362,   -1,   -1,   -1,  366,
   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,
  377,  521,   -1,  380,   -1,  259,  383,  384,  385,  816,
   -1,   -1,  266,   -1,  391,  269,   -1,   -1,  825,   -1,
  397,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  550,   -1,   -1,   -1,   -1,  266,   -1,  414,  269,  559,
  417,  418,  562,   -1,  421,   -1,  423,  424,  425,  426,
  427,  314,  315,  430,  317,   -1,   -1,  320,   -1,   -1,
  314,  315,   -1,  317,   -1,  585,  320,  269,  588,  589,
   -1,  334,   -1,   -1,  594,  595,  596,  597,  598,   -1,
  334,   -1,   -1,  314,  315,   -1,  317,   -1,  608,  320,
   -1,  611,   -1,   -1,  614,   -1,  359,  617,   -1,  619,
   -1,   -1,   -1,  334,   -1,  359,   -1,  627,   -1,   -1,
  630,   -1,  314,  315,  634,  317,   -1,  380,  320,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  380,   -1,  359,   -1,
   -1,   -1,  334,   -1,  397,  398,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  397,  398,   -1,   -1,   -1,   -1,  380,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,
  423,  424,  425,   -1,   -1,   -1,  397,  398,   -1,  423,
  424,  425,   -1,   -1,   -1,   -1,   -1,   -1,  380,   -1,
   -1,  701,   -1,  703,   -1,   -1,   -1,  707,   -1,   -1,
   -1,  711,  423,  424,  425,  397,  398,   -1,   -1,   -1,
  720,  721,   -1,   -1,   -1,   -1,   -1,   -1,  728,  729,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  423,  424,  425,   -1,   -1,   -1,  747,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,  258,  259,  266,
  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,   -1,
   -1,  272,  273,  274,   -1,  276,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,   -1,   -1,   -1,   -1,
   -1,  801,  303,  304,  305,  306,  307,  308,  309,   -1,
  311,  312,   -1,  314,  315,   -1,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,   -1,   -1,
  371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,  424,  425,  426,  427,  256,  429,  430,
  431,  266,  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,
  275,  276,  277,  278,  279,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,   -1,   -1,
   -1,   -1,   -1,   -1,  303,   -1,   -1,   -1,  307,  308,
  309,   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,
  319,  320,  321,  322,  323,   -1,   -1,  326,   -1,  328,
  329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
  339,   -1,  341,  342,   -1,  344,   -1,  346,   -1,  348,
   -1,   -1,  351,  352,  353,  354,   -1,   -1,   -1,  358,
  359,  360,   -1,  362,  363,   -1,  365,   -1,  367,  368,
   -1,   -1,  371,  372,  373,  374,  375,  376,  377,  378,
   -1,  380,   -1,  382,  383,  384,  385,  386,  387,  388,
  389,   -1,  391,   -1,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,   -1,   -1,  417,   -1,
   -1,   -1,  421,  422,  423,  424,  425,  426,  427,  256,
  429,  430,  431,  266,  261,  262,   -1,   -1,   -1,   -1,
   -1,   -1,  275,  276,  277,  278,  279,   -1,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,  303,   -1,   -1,   -1,
  307,  308,  309,   -1,  311,  312,   -1,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,   -1,   -1,  326,
   -1,  328,  329,   -1,  331,  332,  333,  334,  335,  336,
   -1,   -1,   -1,   -1,   -1,  342,   -1,  344,   -1,  346,
   -1,   -1,   -1,   -1,  351,  352,  353,  354,   -1,   -1,
   -1,  358,  359,  360,   -1,  362,   -1,   -1,  365,   -1,
   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,  375,  376,
  377,   -1,   -1,  380,   -1,  382,  383,  384,  385,  386,
  387,  388,  389,   -1,  391,   -1,   -1,   -1,   -1,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410,  411,  412,  256,  414,  266,   -1,
  417,  261,  262,   -1,  421,  422,  423,  424,  425,  426,
  427,   -1,  429,  430,  431,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  303,   -1,   -1,   -1,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,   -1,   -1,  326,   -1,  328,  329,
   -1,  331,  332,  333,  334,  335,  336,   -1,   -1,   -1,
   -1,   -1,  342,   -1,  344,   -1,  346,   -1,   -1,   -1,
   -1,  351,  352,  353,  354,   -1,   -1,   -1,  358,  359,
  360,   -1,  362,   -1,   -1,  365,   -1,   -1,  368,   -1,
   -1,   -1,   -1,   -1,   -1,  375,  376,  377,   -1,   -1,
  380,   -1,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,   -1,   -1,   -1,   -1,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,   -1,  414,   -1,   -1,  417,   -1,   -1,
   -1,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,   -1,  267,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,   -1,   -1,  268,   -1,
   -1,   -1,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,
   -1,  281,   -1,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,   -1,  267,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,  281,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,
   -1,  281,   -1,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,  275,  276,  277,  278,  279,
   -1,  281,  282,  283,  284,  285,  286,   -1,   -1,  289,
  290,  291,  292,  293,  294,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,  313,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
  266,  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,   -1,   -1,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,  266,  261,  262,  263,  264,
  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
  266,  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,   -1,   -1,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,  259,   -1,  261,  262,  263,  264,
  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,  259,
   -1,  261,  262,  263,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,   -1,   -1,  261,  262,  263,  264,
  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  257,  258,   -1,
   -1,  261,  262,  263,  264,   -1,  266,   -1,   -1,   -1,
   -1,   -1,  272,  273,  274,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  257,  258,   -1,   -1,  261,  262,  263,  264,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,   -1,  429,  430,  431,  256,  257,  258,
  259,  266,  261,  262,   -1,   -1,  265,   -1,   -1,   -1,
  275,  276,  277,  278,  279,   -1,   -1,  276,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,   -1,   -1,
   -1,   -1,   -1,   -1,  303,  304,  305,   -1,  307,   -1,
   -1,   -1,  311,  312,   -1,  314,  315,   -1,  317,   -1,
  319,  320,  321,  322,   -1,  324,  325,  326,  327,  328,
   -1,   -1,   -1,  332,  333,  334,  335,  336,   -1,   -1,
   -1,  340,   -1,  342,   -1,  344,  345,   -1,  347,   -1,
  349,  350,   -1,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,   -1,  364,  365,  366,   -1,  368,
   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,  377,   -1,
   -1,  380,  381,   -1,  383,  384,  385,   -1,   -1,   -1,
   -1,   -1,  391,  392,   -1,   -1,   -1,   -1,  397,  398,
  399,  400,   -1,   -1,   -1,   -1,  405,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  414,  415,  416,  417,  418,
  419,  420,  421,   -1,  423,  424,  425,  426,  427,   -1,
   -1,  430,  256,  257,  258,  259,  266,  261,  262,   -1,
   -1,  265,   -1,   -1,   -1,  275,  276,  277,  278,  279,
   -1,   -1,  276,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,  303,
  304,  305,   -1,  307,   -1,   -1,   -1,  311,  312,   -1,
  314,  315,   -1,  317,   -1,  319,  320,  321,  322,   -1,
  324,  325,  326,  327,  328,   -1,   -1,   -1,  332,  333,
  334,  335,  336,   -1,   -1,   -1,  340,   -1,  342,   -1,
  344,  345,   -1,  347,   -1,  349,  350,   -1,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,   -1,
  364,  365,  366,   -1,  368,   -1,   -1,   -1,   -1,   -1,
   -1,  375,   -1,  377,   -1,   -1,  380,  381,   -1,  383,
  384,  385,   -1,   -1,   -1,   -1,   -1,  391,  392,   -1,
   -1,   -1,   -1,  397,  398,  399,  400,   -1,  256,  257,
  258,  259,   -1,  261,  262,   -1,   -1,  265,   -1,   -1,
  414,  415,  416,  417,  418,  419,  420,  421,  276,  423,
  424,  425,  426,  427,   -1,   -1,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  303,  304,  305,   -1,  307,
   -1,   -1,   -1,  311,  312,   -1,  314,  315,   -1,  317,
   -1,  319,  320,   -1,  322,   -1,  324,  325,   -1,  327,
  328,   -1,   -1,   -1,  332,  333,  334,  335,  336,   -1,
   -1,   -1,  340,   -1,  342,   -1,  344,  345,   -1,  347,
   -1,  349,  350,   -1,  352,  353,  354,  355,  356,  357,
  358,  359,   -1,  361,  362,   -1,  364,   -1,  366,   -1,
  368,   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,  377,
   -1,   -1,  380,  381,   -1,  383,  384,  385,   -1,  259,
   -1,  261,  262,  391,  392,  265,   -1,   -1,   -1,  397,
  398,  399,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  414,  415,  416,  417,
  418,  419,  420,  421,   -1,  423,  424,  425,  426,  427,
   -1,   -1,  430,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,  312,   -1,  314,  315,   -1,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,   -1,
   -1,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,   -1,  429,
  430,  431,  259,   -1,  261,  262,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  272,  273,  274,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,  305,  306,
  307,  308,  309,   -1,  311,  312,   -1,  314,  315,   -1,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,   -1,   -1,  371,  372,  373,  374,  375,  376,
  377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
  387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
  417,  418,  419,  420,  421,  422,  423,  424,  425,  426,
  427,   -1,  429,  430,  431,  261,  262,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,  305,
  306,  307,  308,  309,   -1,  311,  312,   -1,  314,  315,
   -1,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,   -1,   -1,  371,  372,  373,  374,  375,
  376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,  411,  412,  413,  414,  415,
  416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
  426,  427,   -1,  429,  430,  431,  261,  262,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,  311,  312,   -1,  314,
  315,   -1,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,   -1,   -1,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,  266,  429,  430,  431,  261,  262,   -1,
   -1,   -1,  275,  276,  277,  278,  279,   -1,   -1,   -1,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  303,
   -1,   -1,   -1,  307,   -1,   -1,   -1,  311,  312,   -1,
  314,  315,   -1,  317,   -1,  319,  320,  256,  322,   -1,
   -1,   -1,   -1,   -1,  328,   -1,   -1,   -1,  332,  333,
  334,  335,  336,   -1,   -1,   -1,   -1,   -1,  342,   -1,
  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  352,  353,
  354,   -1,   -1,   -1,  358,  359,   -1,   -1,  362,   -1,
   -1,   -1,   -1,   -1,  368,   -1,   -1,   -1,   -1,   -1,
   -1,  375,   -1,  377,   -1,   -1,  380,   -1,   -1,  383,
  384,  385,   -1,  322,   -1,   -1,   -1,  391,   -1,   -1,
   -1,  330,   -1,  397,  398,  399,   -1,   -1,  337,  338,
  339,   -1,  341,   -1,   -1,   -1,   -1,   -1,   -1,  348,
  414,   -1,   -1,  417,   -1,   -1,   -1,  421,   -1,  423,
  424,  425,  426,  427,  363,   -1,  430,   -1,  367,   -1,
   -1,   -1,  371,  372,  373,  374,   -1,   -1,   -1,  378,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  393,  394,  395,   -1,  266,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  275,  276,  277,
  278,  279,   -1,   -1,  413,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 431
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_INTEGER_CONST",
"TOK_FLOAT_CONST","TOK_VARIABLE","TOK_QUOTED_VAR","TOK_SYMBOL_CONST",
"TOK_QUOTED_SYMBOL","TOK_OPAQUE_CONST","TOK_INSTANCE_CONST","TOK_LPAREN",
"TOK_RPAREN","TOK_LBRACE","TOK_RBRACE","TOK_LBRACKET","TOK_RBRACKET","TOK_HAT",
"TOK_OR","TOK_AND","TOK_NOT","TOK_PLUS","TOK_MINUS","TOK_TIMES","TOK_DIVIDE",
"TOK_MODULUS","UMINUS","TOK_START_DISJUNCTION","TOK_END_DISJUNCTION",
"TOK_EQUAL","TOK_EQUAL_EQUAL","TOK_APPROX_EQUAL","TOK_NOT_APPROX_EQUAL",
"TOK_SAME_TYPE","TOK_DIFF_TYPE","TOK_NOT_EQ","TOK_NOT_EQUAL","TOK_LESS",
"TOK_LESS_EQUAL","TOK_GREATER","TOK_GREATER_EQUAL","TOK_CONTAINS",
"TOK_DOES_NOT_CONTAIN","TOK_LENGTH_LESS_EQUAL","TOK_LENGTH_NOT_EQUAL",
"TOK_LENGTH_LESS","TOK_LENGTH_EQUAL","TOK_LENGTH_GREATER_EQUAL",
"TOK_LENGTH_GREATER","TOK_ACCEPT","TOK_ACCEPT_ATOM","TOK_ACCEPTLINE_COMPOUND",
"TOK_ACCEPTS","TOK_ACTIVATES","TOK_ADDSTATE","TOK_AFTER","TOK_ALIAS_FOR",
"TOK_ANY","TOK_APPEND","TOK_ARROW","TOK_ASCID","TOK_ASCIZ","TOK_AT","TOK_ATOM",
"TOK_BIND","TOK_BY","TOK_BYTE","TOK_CALL_INHERITED","TOK_CATCH","TOK_CLOSEFILE",
"TOK_COMPOUND","TOK_CONCAT","TOK_COPY","TOK_CRLF","TOK_CS","TOK_DEBUG",
"TOK_DECLARATION_BLOCK","TOK_DEFAULT","TOK_DO","TOK_DOLLAR_LAST",
"TOK_DOUBLE_FLOAT","TOK_EB","TOK_ELSE","TOK_END_BLOCK","TOK_END_GROUP",
"TOK_ENTRY_BLOCK","TOK_EVERY","TOK_EXTERNAL_ROUTINE","TOK_FAILURE",
"TOK_FILENAME","TOK_FILL","TOK_FLOAT","TOK_FOR_EACH","TOK_GENATOM",
"TOK_GENERIC_METHOD","TOK_GENINT","TOK_GET","TOK_IF","TOK_IN",
"TOK_INHERITS_FROM","TOK_INSTANCE","TOK_INTEGER","TOK_IS_OPEN","TOK_LENGTH",
"TOK_LEX","TOK_LONG","TOK_MAKE","TOK_MAX","TOK_MEA","TOK_METHOD","TOK_MIN",
"TOK_MODIFY","TOK_NTH","TOK_OBJECT_CLASS","TOK_OF","TOK_OFF","TOK_ON",
"TOK_ON_EMPTY","TOK_ON_ENTRY","TOK_ON_EVERY","TOK_ON_EXIT","TOK_OPAQUE",
"TOK_OPENFILE","TOK_OUT","TOK_P","TOK_PATHNAME","TOK_POINTER","TOK_POSITION",
"TOK_QUIT","TOK_READ_ONLY","TOK_READ_WRITE","TOK_REFERENCE","TOK_REMOVE_EVERY",
"TOK_REMOVE","TOK_RESTORESTATE","TOK_RETURN","TOK_RETURNS","TOK_RG","TOK_RJUST",
"TOK_RULE","TOK_RULE_BLOCK","TOK_RULE_GROUP","TOK_SAVESTATE","TOK_SHORT",
"TOK_SINGLE_FLOAT","TOK_SCALAR","TOK_SPECIALIZE","TOK_SQL_ATTACH",
"TOK_SQL_COMMIT","TOK_SQL_DELETE","TOK_SQL_DETACH","TOK_SQL_FETCH_AS_OBJECT",
"TOK_SQL_FETCH_EACH","TOK_SQL_INSERT","TOK_SQL_INSERT_FROM_OBJECT",
"TOK_SQL_ROLLBACK","TOK_SQL_START","TOK_SQL_UPDATE",
"TOK_SQL_UPDATE_FROM_OBJECT","TOK_STARTUP","TOK_STRATEGY","TOK_SUBCOMPOUND",
"TOK_SUBSYMBOL","TOK_SUCCESS","TOK_SYMBOL","TOK_SYMBOL_LENGTH","TOK_TABTO",
"TOK_THEN","TOK_TRACE","TOK_UNSIGNED_BYTE","TOK_UNSIGNED_LONG",
"TOK_UNSIGNED_SHORT","TOK_USES","TOK_VALUE","TOK_WHEN","TOK_WHILE","TOK_WM",
"TOK_WRITE",
};
char *yyrule[] = {
"$accept : program_construct",
"$$1 :",
"program_construct : TOK_LPAREN $$1 program_line TOK_RPAREN",
"program_construct : error",
"program_line : declaration_block",
"program_line : entry_block",
"program_line : rule_block",
"program_line : end_block",
"program_line : rule_group_declaration",
"program_line : end_rule_group",
"program_line : object_class_declaration",
"program_line : method_declaration",
"program_line : generic_method_declaration",
"program_line : external_routine_declaration",
"program_line : on_entry",
"program_line : on_empty",
"program_line : on_exit",
"program_line : on_every",
"program_line : rule",
"program_line : catcher",
"program_line : error",
"$$2 :",
"declaration_block : TOK_DECLARATION_BLOCK $$2 name",
"$$3 :",
"entry_block : TOK_ENTRY_BLOCK name $$3 opt_entry_block_clauses",
"opt_entry_block_clauses :",
"opt_entry_block_clauses : opt_entry_block_clauses TOK_LPAREN entry_block_clause TOK_RPAREN",
"entry_block_clause : accepts_clause",
"entry_block_clause : returns_clause",
"entry_block_clause : activates_clause",
"entry_block_clause : uses_clause",
"entry_block_clause : strategy_clause",
"activates_clause : TOK_ACTIVATES names",
"uses_clause : TOK_USES names",
"strategy_clause : TOK_STRATEGY strategy_name",
"$$4 :",
"on_entry : TOK_ON_ENTRY $$4 startup_actions",
"on_entry : TOK_STARTUP startup_actions",
"$$5 :",
"on_empty : TOK_ON_EMPTY $$5 actions",
"$$6 :",
"on_exit : TOK_ON_EXIT $$6 actions",
"$$7 :",
"on_every : TOK_ON_EVERY $$7 actions",
"startup_actions : TOK_LPAREN startup_action TOK_RPAREN",
"startup_actions : startup_actions TOK_LPAREN startup_action TOK_RPAREN",
"startup_action : action",
"startup_action : at_command",
"at_command : TOK_AT name",
"opt_actions :",
"opt_actions : actions",
"opt_method_actions :",
"opt_method_actions : actions",
"actions : action_line",
"actions : actions action_line",
"actions : error",
"action_line : TOK_LPAREN action TOK_RPAREN",
"action_line : TOK_LPAREN construct_keyword",
"action : addstate_action",
"action : after_action",
"action : bind_action",
"action : call_inherited",
"action : closefile_action",
"action : copy_action",
"action : debug_action",
"action : default_action",
"action : for_each_action",
"action : function_call",
"action : if_action",
"action : make_action",
"action : modify_action",
"action : openfile_action",
"action : quit_action",
"action : remove_action",
"action : remove_every_action",
"action : restorestate_action",
"action : return_action",
"action : savestate_action",
"action : specialize_action",
"action : trace_action",
"action : while_action",
"action : write_action",
"action : sql_attach_action",
"action : sql_commit_action",
"action : sql_delete_action",
"action : sql_detach_action",
"action : sql_fetch_each_action",
"action : sql_fetch_as_object_action",
"action : sql_insert_action",
"action : sql_insert_from_object_action",
"action : sql_rollback_action",
"action : sql_start_action",
"action : sql_update_action",
"action : sql_update_from_object_action",
"action : error",
"addstate_action : TOK_ADDSTATE value",
"after_action : TOK_AFTER value name",
"bind_action : TOK_BIND variable value",
"call_inherited : TOK_CALL_INHERITED variables",
"closefile_action : TOK_CLOSEFILE value_list",
"copy_action : TOK_COPY variable opt_rhs_terms",
"debug_action : TOK_DEBUG",
"default_action : TOK_DEFAULT value value",
"for_each_action : TOK_FOR_EACH variable TOK_IN value actions",
"if_action : TOK_IF expression TOK_THEN actions opt_else",
"make_action : TOK_MAKE rclass opt_rhs_terms",
"modify_action : TOK_MODIFY variable opt_rhs_terms",
"openfile_action : TOK_OPENFILE value value value",
"quit_action : TOK_QUIT opt_quit_value",
"opt_quit_value :",
"opt_quit_value : arith_value",
"opt_quit_value : TOK_FAILURE",
"opt_quit_value : TOK_SUCCESS",
"remove_action : TOK_REMOVE variables",
"remove_every_action : TOK_REMOVE_EVERY classes",
"restorestate_action : TOK_RESTORESTATE value",
"return_action : TOK_RETURN opt_value",
"savestate_action : TOK_SAVESTATE value",
"specialize_action : TOK_SPECIALIZE variable rclass opt_rhs_terms",
"trace_action : TOK_TRACE on_off trace_options",
"while_action : TOK_WHILE expression TOK_DO actions",
"write_action : TOK_WRITE opt_values",
"sql_attach_action : TOK_SQL_ATTACH db_spec opt_db_scope",
"sql_commit_action : TOK_SQL_COMMIT",
"sql_delete_action : TOK_SQL_DELETE db_table opt_sql_rse",
"sql_detach_action : TOK_SQL_DETACH",
"sql_fetch_each_action : TOK_SQL_FETCH_EACH db_vars TOK_LPAREN sql_rse TOK_RPAREN sql_actions",
"sql_fetch_as_object_action : TOK_SQL_FETCH_AS_OBJECT sql_rse",
"sql_insert_action : TOK_SQL_INSERT db_table sql_rse",
"sql_insert_from_object_action : TOK_SQL_INSERT_FROM_OBJECT variable",
"sql_rollback_action : TOK_SQL_ROLLBACK",
"sql_start_action : TOK_SQL_START opt_sql_rse",
"sql_update_action : TOK_SQL_UPDATE db_table sql_rse",
"sql_update_from_object_action : TOK_SQL_UPDATE_FROM_OBJECT variable opt_sql_rse",
"db_spec : TOK_FILENAME name",
"db_spec : TOK_PATHNAME name",
"db_spec : db_spec_name",
"opt_db_scope :",
"opt_db_scope : db_scope",
"db_scope : name",
"db_table : name",
"db_vars : variables",
"opt_sql_rse :",
"opt_sql_rse : sql_rse",
"sql_actions : actions",
"sql_rse : sql_rse_list",
"sql_rse_list : sql_rse_list sql_rse_element",
"sql_rse_list : sql_rse_element",
"sql_rse_element : constant",
"sql_rse_element : variable",
"sql_rse_element : quoted_var",
"sql_rse_element : TOK_EQUAL",
"sql_rse_element : TOK_EQUAL_EQUAL",
"sql_rse_element : TOK_APPROX_EQUAL",
"sql_rse_element : TOK_NOT_APPROX_EQUAL",
"sql_rse_element : TOK_NOT_EQ",
"sql_rse_element : TOK_NOT_EQUAL",
"sql_rse_element : TOK_GREATER",
"sql_rse_element : TOK_GREATER_EQUAL",
"sql_rse_element : TOK_LESS",
"sql_rse_element : TOK_LESS_EQUAL",
"sql_rse_element : TOK_PLUS",
"sql_rse_element : TOK_MINUS",
"sql_rse_element : TOK_TIMES",
"sql_rse_element : TOK_DIVIDE",
"sql_rse_element : TOK_MODULUS",
"sql_rse_element : TOK_ARROW",
"sql_rse_element : TOK_START_DISJUNCTION",
"sql_rse_element : TOK_END_DISJUNCTION",
"opt_rhs_terms :",
"opt_rhs_terms : opt_rhs_terms rhs_term",
"rhs_term : TOK_HAT attribute opt_ca_access value",
"rhs_term : error",
"rclass : name",
"rclass : variable",
"rclass : TOK_LPAREN accept_atom_bti TOK_RPAREN",
"rclass : TOK_LPAREN concat_bti TOK_RPAREN",
"rclass : TOK_LPAREN get_bti TOK_RPAREN",
"rclass : TOK_LPAREN nth_bti TOK_RPAREN",
"rclass : TOK_LPAREN symbol_bti TOK_RPAREN",
"rclass : TOK_LPAREN function_call TOK_RPAREN",
"classes : classes rclass",
"classes : rclass",
"attribute : name",
"attribute : variable",
"$$8 :",
"catcher : TOK_CATCH name $$8 opt_actions",
"expression : TOK_LPAREN cmplx_expre TOK_RPAREN",
"cmplx_expre : expre_value",
"cmplx_expre : cmplx_expre TOK_AND cmplx_expre",
"cmplx_expre : cmplx_expre TOK_OR cmplx_expre",
"cmplx_expre : TOK_NOT expre_value",
"expre_value : value_non_sql predicate value_non_sql",
"expre_value : TOK_LPAREN cmplx_expre TOK_RPAREN",
"opt_else :",
"opt_else : TOK_ELSE actions",
"built_ins : accept_atom_bti",
"built_ins : acceptline_compound_bti",
"built_ins : compound_bti",
"built_ins : concat_bti",
"built_ins : crlf_bti",
"built_ins : every_bti",
"built_ins : float_bti",
"built_ins : genatom_bti",
"built_ins : genint_bti",
"built_ins : get_bti",
"built_ins : integer_bti",
"built_ins : is_open_bti",
"built_ins : length_bti",
"built_ins : max_bti",
"built_ins : min_bti",
"built_ins : nth_bti",
"built_ins : position_bti",
"built_ins : rjust_bti",
"built_ins : subcompound_bti",
"built_ins : subsymbol_bti",
"built_ins : symbol_bti",
"built_ins : symbol_len_bti",
"built_ins : tabto_bti",
"accept_atom_bti : TOK_ACCEPT_ATOM opt_value",
"acceptline_compound_bti : TOK_ACCEPTLINE_COMPOUND opt_accpt_compound",
"opt_accpt_compound :",
"opt_accpt_compound : value opt_value",
"compound_bti : TOK_COMPOUND opt_values",
"concat_bti : TOK_CONCAT opt_values",
"crlf_bti : TOK_CRLF",
"every_bti : TOK_EVERY rclass",
"float_bti : TOK_FLOAT value",
"genatom_bti : TOK_GENATOM opt_value",
"genint_bti : TOK_GENINT",
"get_bti : TOK_GET value TOK_HAT attribute",
"integer_bti : TOK_INTEGER value",
"is_open_bti : TOK_IS_OPEN value",
"length_bti : TOK_LENGTH value",
"max_bti : TOK_MAX opt_values",
"min_bti : TOK_MIN opt_values",
"nth_bti : TOK_NTH value index_num",
"position_bti : TOK_POSITION value opt_predicate value",
"rjust_bti : TOK_RJUST value",
"subcompound_bti : TOK_SUBCOMPOUND value index_num index_num",
"subsymbol_bti : TOK_SUBSYMBOL value index_num index_num",
"symbol_bti : TOK_SYMBOL value",
"symbol_len_bti : TOK_SYMBOL_LENGTH value",
"tabto_bti : TOK_TABTO value",
"$$9 :",
"rule_block : TOK_RULE_BLOCK name $$9 opt_rule_block_clauses",
"opt_rule_block_clauses :",
"opt_rule_block_clauses : opt_rule_block_clauses TOK_LPAREN rule_block_clause TOK_RPAREN",
"rule_block_clause : uses_clause",
"rule_block_clause : strategy_clause",
"strategy_name : TOK_LEX",
"strategy_name : TOK_MEA",
"$$10 :",
"end_block : TOK_END_BLOCK $$10 opt_name",
"rule_group_declaration : TOK_RULE_GROUP name",
"end_rule_group : TOK_END_GROUP opt_name",
"$$11 :",
"object_class_declaration : TOK_OBJECT_CLASS name $$11 opt_object_class_modifier opt_attribute_declarations",
"opt_object_class_modifier :",
"opt_object_class_modifier : TOK_LPAREN TOK_INHERITS_FROM name TOK_RPAREN",
"opt_attribute_declarations :",
"opt_attribute_declarations : opt_attribute_declarations attribute_declaration",
"attribute_declaration : TOK_HAT attribute_name opt_compound_flag opt_domain_restriction opt_attribute_modifiers",
"attribute_name : name",
"opt_compound_flag :",
"opt_compound_flag : TOK_COMPOUND",
"opt_domain_restriction :",
"opt_domain_restriction : TOK_ANY",
"opt_domain_restriction : TOK_INSTANCE opt_domain_class",
"opt_domain_restriction : TOK_INTEGER",
"opt_domain_restriction : TOK_FLOAT",
"opt_domain_restriction : TOK_OPAQUE",
"opt_domain_restriction : TOK_SYMBOL",
"opt_domain_class :",
"opt_domain_class : TOK_OF name",
"opt_attribute_modifiers :",
"opt_attribute_modifiers : opt_attribute_modifiers attribute_modifier",
"attribute_modifier : TOK_LPAREN TOK_DEFAULT constant TOK_RPAREN",
"attribute_modifier : TOK_LPAREN TOK_DEFAULT compound_const TOK_RPAREN",
"attribute_modifier : TOK_LPAREN TOK_FILL constant TOK_RPAREN",
"$$12 :",
"generic_method_declaration : TOK_GENERIC_METHOD allowable_func_name $$12 generic_method_accepts_clause opt_generic_method_returns",
"generic_method_accepts_clause : TOK_LPAREN TOK_ACCEPTS generic_method_when_decl opt_method_param_decls TOK_RPAREN",
"opt_generic_method_returns :",
"opt_generic_method_returns : TOK_LPAREN TOK_RETURNS method_return_param TOK_RPAREN",
"generic_method_when_decl : variable TOK_WHEN TOK_INSTANCE opt_domain_class",
"$$13 :",
"method_declaration : TOK_METHOD allowable_func_name $$13 method_accepts_clause opt_method_returns_plus_actions",
"method_accepts_clause : TOK_LPAREN TOK_ACCEPTS method_when_decl opt_method_param_decls TOK_RPAREN",
"method_when_decl : variable TOK_WHEN TOK_INSTANCE TOK_OF name",
"method_param_decl : variable opt_method_param_opts",
"opt_method_param_decls :",
"opt_method_param_decls : opt_method_param_decls method_param_decl",
"opt_method_returns_plus_actions : TOK_LPAREN action TOK_RPAREN opt_method_actions",
"opt_method_returns_plus_actions : TOK_LPAREN TOK_RETURNS method_return_param TOK_RPAREN opt_actions",
"method_return_param : variable opt_method_param_opts",
"opt_method_param_opts : opt_compound_flag opt_domain_restriction",
"$$14 :",
"external_routine_declaration : TOK_EXTERNAL_ROUTINE allowable_func_name $$14 opt_ext_rt_clauses",
"opt_ext_rt_clauses :",
"opt_ext_rt_clauses : TOK_LPAREN ext_rt_clause TOK_RPAREN opt_ext_rt_clauses",
"ext_rt_clause : alias_clause",
"ext_rt_clause : accepts_clause",
"ext_rt_clause : returns_clause",
"alias_clause : TOK_ALIAS_FOR name",
"accepts_clause : TOK_ACCEPTS ext_rt_param_decl opt_ext_rt_param_decls",
"returns_clause : TOK_RETURNS ext_rt_return_decl",
"ext_rt_param_decl : opt_param_name opt_param_cardinality param_type opt_param_mech",
"opt_ext_rt_param_decls :",
"opt_ext_rt_param_decls : ext_rt_param_decl opt_ext_rt_param_decls",
"ext_rt_return_decl : opt_param_name opt_param_cardinality param_type opt_return_mech",
"opt_param_name :",
"opt_param_name : variable",
"opt_param_cardinality :",
"opt_param_cardinality : TOK_LBRACKET param_array_length TOK_RBRACKET",
"param_type : TOK_LONG",
"param_type : TOK_SHORT",
"param_type : TOK_BYTE",
"param_type : TOK_UNSIGNED_LONG",
"param_type : TOK_UNSIGNED_SHORT",
"param_type : TOK_UNSIGNED_BYTE",
"param_type : TOK_SINGLE_FLOAT",
"param_type : TOK_DOUBLE_FLOAT",
"param_type : TOK_ASCIZ",
"param_type : TOK_ASCID",
"param_type : TOK_POINTER",
"param_type : TOK_ATOM",
"opt_param_mech :",
"opt_param_mech : TOK_BY TOK_REFERENCE TOK_READ_ONLY",
"opt_param_mech : TOK_BY TOK_REFERENCE TOK_READ_WRITE",
"opt_param_mech : TOK_BY TOK_VALUE",
"opt_return_mech :",
"opt_return_mech : TOK_BY TOK_REFERENCE",
"opt_return_mech : TOK_BY TOK_VALUE",
"param_array_length :",
"param_array_length : TOK_INTEGER_CONST",
"param_array_length : variable",
"$$15 :",
"rule : rule_or_p name $$15 ce_form opt_ce_list TOK_ARROW opt_actions",
"rule_or_p : TOK_RULE",
"rule_or_p : TOK_P",
"opt_ce_list :",
"opt_ce_list : opt_ce_list ce",
"ce : pos_ce",
"ce : neg_ce",
"pos_ce : ce_form",
"neg_ce : TOK_MINUS ce_form",
"ce_form : TOK_LPAREN name opt_lhs_terms TOK_RPAREN",
"ce_form : TOK_LPAREN name opt_lhs_terms TOK_ARROW",
"ce_form : error",
"opt_lhs_terms :",
"opt_lhs_terms : opt_lhs_terms lhs_term",
"lhs_term : TOK_HAT name opt_ca_access lhs_value",
"lhs_term : error",
"opt_ca_access :",
"opt_ca_access : TOK_LBRACKET ca_index TOK_RBRACKET",
"ca_index : arith_expr",
"ca_index : TOK_DOLLAR_LAST",
"index_num : integer_const",
"index_num : variable",
"index_num : TOK_LPAREN built_ins TOK_RPAREN",
"index_num : TOK_LPAREN function_call TOK_RPAREN",
"index_num : TOK_LPAREN arith_expr TOK_RPAREN",
"index_num : TOK_DOLLAR_LAST",
"lhs_value : restriction",
"lhs_value : TOK_LBRACE restriction_list TOK_RBRACE",
"restriction_list : restriction_list restriction",
"restriction_list : restriction",
"restriction : TOK_START_DISJUNCTION value_list TOK_END_DISJUNCTION",
"restriction : predicate value",
"restriction : value",
"arith_expr : arith_value",
"arith_expr : arith_expr TOK_PLUS arith_expr",
"arith_expr : arith_expr TOK_MINUS arith_expr",
"arith_expr : arith_expr TOK_TIMES arith_expr",
"arith_expr : arith_expr TOK_DIVIDE arith_expr",
"arith_expr : arith_expr TOK_MODULUS arith_expr",
"arith_expr : TOK_MINUS arith_value",
"arith_value : integer_const",
"arith_value : float_const",
"arith_value : variable",
"arith_value : TOK_LPAREN built_ins TOK_RPAREN",
"arith_value : TOK_LPAREN function_call TOK_RPAREN",
"arith_value : TOK_LPAREN arith_expr TOK_RPAREN",
"arith_value : error",
"on_off : TOK_OFF",
"on_off : TOK_ON",
"trace_options : TOK_TIMES",
"trace_options : trace_names",
"trace_names : trace_name",
"trace_names : trace_names trace_name",
"trace_name : TOK_ENTRY_BLOCK",
"trace_name : TOK_EB",
"trace_name : TOK_RULE_GROUP",
"trace_name : TOK_RG",
"trace_name : TOK_RULE",
"trace_name : TOK_WM",
"trace_name : TOK_CS",
"variables : variables variable",
"variables : variable",
"function_call : allowable_func_name opt_values",
"value_list : value",
"value_list : value_list value",
"opt_value :",
"opt_value : value",
"opt_values :",
"opt_values : opt_values value",
"value : value_non_sql",
"value : TOK_LPAREN sql_fetch_as_object_action TOK_RPAREN",
"value_non_sql : constant",
"value_non_sql : variable",
"value_non_sql : TOK_LPAREN built_ins TOK_RPAREN",
"value_non_sql : TOK_LPAREN function_call TOK_RPAREN",
"value_non_sql : TOK_LPAREN arith_expr TOK_RPAREN",
"value_non_sql : TOK_LPAREN copy_action TOK_RPAREN",
"value_non_sql : TOK_LPAREN make_action TOK_RPAREN",
"value_non_sql : TOK_LPAREN modify_action TOK_RPAREN",
"value_non_sql : TOK_LPAREN specialize_action TOK_RPAREN",
"value_non_sql : TOK_LPAREN call_inherited TOK_RPAREN",
"constant : integer_const",
"constant : float_const",
"constant : opaque_const",
"constant : instance_const",
"constant : name",
"names : names name",
"names : name",
"opt_name :",
"opt_name : name",
"name : allowable_func_name",
"name : built_in_keyword",
"name : construct_keyword",
"name : action_token",
"name : sql_keyword",
"db_spec_name : allowable_func_name",
"db_spec_name : built_in_keyword",
"db_spec_name : construct_keyword",
"db_spec_name : action_token",
"allowable_func_name : symbol_const",
"allowable_func_name : quoted_symbol",
"allowable_func_name : allowable_func_keyword",
"construct_keyword : TOK_DECLARATION_BLOCK",
"construct_keyword : TOK_END_BLOCK",
"construct_keyword : TOK_END_GROUP",
"construct_keyword : TOK_ENTRY_BLOCK",
"construct_keyword : TOK_EXTERNAL_ROUTINE",
"construct_keyword : TOK_GENERIC_METHOD",
"construct_keyword : TOK_METHOD",
"construct_keyword : TOK_OBJECT_CLASS",
"construct_keyword : TOK_ON_EMPTY",
"construct_keyword : TOK_ON_ENTRY",
"construct_keyword : TOK_STARTUP",
"construct_keyword : TOK_ON_EVERY",
"construct_keyword : TOK_ON_EXIT",
"construct_keyword : TOK_P",
"construct_keyword : TOK_RULE",
"construct_keyword : TOK_RULE_BLOCK",
"construct_keyword : TOK_RULE_GROUP",
"built_in_keyword : TOK_ACCEPT_ATOM",
"built_in_keyword : TOK_ACCEPTLINE_COMPOUND",
"built_in_keyword : TOK_ACCEPTS",
"built_in_keyword : TOK_COMPOUND",
"built_in_keyword : TOK_CONCAT",
"built_in_keyword : TOK_CRLF",
"built_in_keyword : TOK_EVERY",
"built_in_keyword : TOK_FLOAT",
"built_in_keyword : TOK_GENATOM",
"built_in_keyword : TOK_GENINT",
"built_in_keyword : TOK_GET",
"built_in_keyword : TOK_INTEGER",
"built_in_keyword : TOK_IS_OPEN",
"built_in_keyword : TOK_LENGTH",
"built_in_keyword : TOK_MAX",
"built_in_keyword : TOK_MIN",
"built_in_keyword : TOK_NTH",
"built_in_keyword : TOK_POSITION",
"built_in_keyword : TOK_RETURNS",
"built_in_keyword : TOK_RJUST",
"built_in_keyword : TOK_SUBCOMPOUND",
"built_in_keyword : TOK_SUBSYMBOL",
"built_in_keyword : TOK_SYMBOL",
"built_in_keyword : TOK_SYMBOL_LENGTH",
"built_in_keyword : TOK_TABTO",
"built_in_keyword : TOK_AND",
"built_in_keyword : TOK_NOT",
"built_in_keyword : TOK_OR",
"allowable_func_keyword : TOK_ACCEPT",
"allowable_func_keyword : TOK_ACTIVATES",
"allowable_func_keyword : TOK_ANY",
"allowable_func_keyword : TOK_APPEND",
"allowable_func_keyword : TOK_ASCID",
"allowable_func_keyword : TOK_ASCIZ",
"allowable_func_keyword : TOK_ATOM",
"allowable_func_keyword : TOK_BY",
"allowable_func_keyword : TOK_BYTE",
"allowable_func_keyword : TOK_CATCH",
"allowable_func_keyword : TOK_CS",
"allowable_func_keyword : TOK_DO",
"allowable_func_keyword : TOK_DOLLAR_LAST",
"allowable_func_keyword : TOK_DOUBLE_FLOAT",
"allowable_func_keyword : TOK_EB",
"allowable_func_keyword : TOK_ELSE",
"allowable_func_keyword : TOK_FAILURE",
"allowable_func_keyword : TOK_FILL",
"allowable_func_keyword : TOK_IN",
"allowable_func_keyword : TOK_INHERITS_FROM",
"allowable_func_keyword : TOK_INSTANCE",
"allowable_func_keyword : TOK_LEX",
"allowable_func_keyword : TOK_LONG",
"allowable_func_keyword : TOK_MEA",
"allowable_func_keyword : TOK_OF",
"allowable_func_keyword : TOK_OUT",
"allowable_func_keyword : TOK_OPAQUE",
"allowable_func_keyword : TOK_POINTER",
"allowable_func_keyword : TOK_READ_ONLY",
"allowable_func_keyword : TOK_READ_WRITE",
"allowable_func_keyword : TOK_REFERENCE",
"allowable_func_keyword : TOK_RG",
"allowable_func_keyword : TOK_SHORT",
"allowable_func_keyword : TOK_SINGLE_FLOAT",
"allowable_func_keyword : TOK_SCALAR",
"allowable_func_keyword : TOK_STRATEGY",
"allowable_func_keyword : TOK_SUCCESS",
"allowable_func_keyword : TOK_THEN",
"allowable_func_keyword : TOK_UNSIGNED_BYTE",
"allowable_func_keyword : TOK_UNSIGNED_LONG",
"allowable_func_keyword : TOK_UNSIGNED_SHORT",
"allowable_func_keyword : TOK_USES",
"allowable_func_keyword : TOK_VALUE",
"allowable_func_keyword : TOK_WM",
"action_token : TOK_ADDSTATE",
"action_token : TOK_AFTER",
"action_token : TOK_BIND",
"action_token : TOK_CALL_INHERITED",
"action_token : TOK_CLOSEFILE",
"action_token : TOK_COPY",
"action_token : TOK_DEBUG",
"action_token : TOK_DEFAULT",
"action_token : TOK_FOR_EACH",
"action_token : TOK_IF",
"action_token : TOK_MAKE",
"action_token : TOK_MODIFY",
"action_token : TOK_OPENFILE",
"action_token : TOK_QUIT",
"action_token : TOK_REMOVE",
"action_token : TOK_REMOVE_EVERY",
"action_token : TOK_RESTORESTATE",
"action_token : TOK_RETURN",
"action_token : TOK_SAVESTATE",
"action_token : TOK_SPECIALIZE",
"action_token : TOK_TRACE",
"action_token : TOK_WHILE",
"action_token : TOK_WRITE",
"action_token : TOK_SQL_ATTACH",
"action_token : TOK_SQL_COMMIT",
"action_token : TOK_SQL_DELETE",
"action_token : TOK_SQL_DETACH",
"action_token : TOK_SQL_FETCH_EACH",
"action_token : TOK_SQL_FETCH_AS_OBJECT",
"action_token : TOK_SQL_INSERT",
"action_token : TOK_SQL_INSERT_FROM_OBJECT",
"action_token : TOK_SQL_ROLLBACK",
"action_token : TOK_SQL_START",
"action_token : TOK_SQL_UPDATE",
"action_token : TOK_SQL_UPDATE_FROM_OBJECT",
"sql_keyword : TOK_FILENAME",
"sql_keyword : TOK_PATHNAME",
"opt_predicate :",
"opt_predicate : scalar_predicate",
"predicate : scalar_predicate",
"predicate : content_predicate",
"scalar_predicate : TOK_SAME_TYPE",
"scalar_predicate : TOK_DIFF_TYPE",
"scalar_predicate : TOK_EQUAL",
"scalar_predicate : TOK_EQUAL_EQUAL",
"scalar_predicate : TOK_APPROX_EQUAL",
"scalar_predicate : TOK_NOT_APPROX_EQUAL",
"scalar_predicate : TOK_NOT_EQ",
"scalar_predicate : TOK_NOT_EQUAL",
"scalar_predicate : TOK_GREATER",
"scalar_predicate : TOK_GREATER_EQUAL",
"scalar_predicate : TOK_LESS",
"scalar_predicate : TOK_LESS_EQUAL",
"content_predicate : TOK_LENGTH_EQUAL",
"content_predicate : TOK_LENGTH_NOT_EQUAL",
"content_predicate : TOK_LENGTH_GREATER",
"content_predicate : TOK_LENGTH_GREATER_EQUAL",
"content_predicate : TOK_LENGTH_LESS",
"content_predicate : TOK_LENGTH_LESS_EQUAL",
"content_predicate : TOK_CONTAINS",
"content_predicate : TOK_DOES_NOT_CONTAIN",
"content_predicate : TOK_CONTAINS scalar_predicate",
"content_predicate : TOK_DOES_NOT_CONTAIN scalar_predicate",
"content_predicate : scalar_predicate TOK_CONTAINS",
"content_predicate : scalar_predicate TOK_DOES_NOT_CONTAIN",
"compound_const : TOK_LPAREN TOK_COMPOUND opt_comp_element_const TOK_RPAREN",
"opt_comp_element_const :",
"opt_comp_element_const : opt_comp_element_const constant",
"integer_const : TOK_INTEGER_CONST",
"float_const : TOK_FLOAT_CONST",
"variable : TOK_VARIABLE",
"quoted_var : TOK_QUOTED_VAR",
"symbol_const : TOK_SYMBOL_CONST",
"quoted_symbol : TOK_QUOTED_SYMBOL",
"opaque_const : TOK_OPAQUE_CONST",
"instance_const : TOK_INSTANCE_CONST",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 2934 "../source/c_parser.y"


/****************************************************************************/
/* C CODE SECTION							    */


static Ast_Node compound_is_a_constant (Ast_Node ast)
{
  Ast_Node node;
  long     i;
  Molecule tmp_comp;

  rul__mol_start_tmp_comp (10);

  for (node = ast, i = 0;
       node != NULL;
       node = rul__ast_get_sibling (node), i++) {

    if (rul__ast_get_type (node) != AST__E_CONSTANT) {
      tmp_comp = rul__mol_end_tmp_comp ();
      rul__mol_decr_uses (tmp_comp);
      return NULL;
    }
    rul__mol_set_tmp_comp_nth (i, rul__ast_get_value (node));
  }

  node = rul__ast_mol_node (AST__E_CONSTANT, rul__mol_end_tmp_comp ());
  return node;
}



static Boolean		SB_in_construct = FALSE;
static Ast_Node_Type 	SA_construct_type = AST__E_INVALID;
static char	 	SC_construct_name[RUL_C_MAX_SYMBOL_SIZE+1];


/*******************
**                **
**  IN_CONSTRUCT  **
**                **
*******************/

static Boolean in_construct (void)
{
	return (SB_in_construct);
}


/***********************
**                    **
**  SET_IN_CONSTRUCT  **
**                    **
***********************/

static void set_in_construct (void)
{
	SB_in_construct = TRUE;
	SA_construct_type = AST__E_INVALID;
	SC_construct_name[0] = '\0';
}


/**************************************
**                                   **
**  RUL__PARSER_DONE_WITH_CONSTRUCT  **
**                                   **
**************************************/

void rul__parser_done_with_construct (void)
{
	SB_in_construct = FALSE;
	SA_construct_type = AST__E_INVALID;
	SC_construct_name[0] = '\0';
}


/*************************
**                      **
**  GET_CONSTRUCT_TYPE  **
**                      **
*************************/

static Ast_Node_Type get_construct_type (void)
{
	return (SA_construct_type);
}



/*****************************
**                          **
**  CONSTRUCT_TYPE_TO_NAME  **
**                          **
*****************************/

static char *construct_type_to_name (Ast_Node_Type con_type)
{
	switch (con_type) {

	    case AST__E_ENTRY_BLOCK :
			return ("ENTRY-BLOCK");
			break;
	    case AST__E_DECL_BLOCK :
			return ("DECLARATION-BLOCK");
			break;
	    case AST__E_RULE_BLOCK :
			return ("RULE-BLOCK");
			break;
	    case AST__E_END_BLOCK :
			return ("END-BLOCK");
			break;

	    case AST__E_OBJ_CLASS :
			return ("OBJECT-CLASS");
			break;
	    case AST__E_EXT_RT_DECL :
			return ("EXTERNAL-ROUTINE");
			break;

	    case AST__E_CATCH :		
			return ("CATCH");
			break;
	    case AST__E_RULE :
			return ("RULE");
			break;

	    case AST__E_METHOD :
			return ("METHOD");
			break;
	    case AST__E_GENERIC_METHOD :
			return ("GENERIC-METHOD");
			break;

	    case AST__E_RULE_GROUP :
			return ("RULE-GROUP");
			break;
	    case AST__E_END_GROUP :
			return ("END-GROUP statement");
			break;

	    case AST__E_ON_ENTRY :
			return ("ON-ENTRY statement");
			break;
	    case AST__E_ON_EMPTY :
			return ("ON-EMPTY statement");
			break;
	    case AST__E_ON_EXIT :
			return ("ON-EXIT statement");
			break;
	    case AST__E_ON_EVERY :
			return ("ON-EVERY statement");
			break;

	    default:
			return (NULL);
			break;
	}
}



/************************
**                     **
**  SET_CUR_CONSTRUCT  **
**                     **
************************/

static void set_cur_construct (Ast_Node_Type typ, Ast_Node ast)
{
	Mol_Symbol sym;

	SA_construct_type = typ;

	if (ast != NULL  &&  rul__ast_get_value_type (ast) == AST__E_TYPE_MOL) {
	    sym = (Mol_Symbol) rul__ast_get_value (ast);
	    rul__mol_use_printform (sym, SC_construct_name, 
				RUL_C_MAX_SYMBOL_SIZE+1);
	}
}


/*************************
**                      **
**  GET_CONSTRUCT_NAME  **
**                      **
*************************/

static char *get_construct_name (void)
{
	return (SC_construct_name);
}



/**********************
**                   **
**  UPCASE_IN_PLACE  **
**                   **
**********************/

static char *upcase_in_place (char *str)
{
	long i, len;

	len = strlen(str);
	for (i=0; i<len; i++) str[i] = toupper(str[i]);
	return (str);
}

static Boolean SB_syntax_error = FALSE;



/******************
**               **
**  CLEAR_ERROR  **
**               **
******************/

static void clear_error (void)
{
	SB_syntax_error = FALSE;
}


/****************
**             **
**  SET_ERROR  **
**             **
****************/

static void set_error (void)
{
	SB_syntax_error = TRUE;
}


/***************
**            **
**  IN_ERROR  **
**            **
***************/

static Boolean in_error (void)
{
	return (SB_syntax_error);
}




/**************
**           **
**  YYERROR  **
**           **
**************/

static void yyerror (char *msg)
	/*
	**	Construct and post an appropriate error message
	*/
{
	char *str, buffer[100], err_msg[100];
	char near_msg[RUL_C_MAX_SYMBOL_SIZE+25];
	Token_Type typ;
	Token_Value val;

	if (SB_syntax_error) {
            /*
            **   If we are in the middle of a statement which
            **   we already know contains an error, clear the
            **   input buffer and continue.
	    */
	    return;
	}
	set_error ();

	typ = rul__scan_get_last_token (&val);

	switch (typ /* current token type */) {

	    case TOK_FLOAT_CONST :
			sprintf (buffer, "%f", val.fval);
			str = buffer;
			break;

	    case TOK_INTEGER_CONST :
			sprintf (buffer, "%ld", val.ival);
			str = buffer;
			break;

	    case TOK_OPAQUE_CONST :
			sprintf (buffer, "%%x%p", val.ival);
			str = buffer;
			break;

	    case TOK_INSTANCE_CONST :
			sprintf (buffer, "#%ld", val.ival);
			str = buffer;
			break;

	    case 0 :	/* End-Of-File */
			if (in_construct()) {
			    rul__msg_cmp_print_w_line (
				    CMP_UNEXPEOF, SL_line_number, "");
			}
			return;

	    default :
			str = val.sval;
	}

	if ((strcmp (msg, "Syntax error") == 0) ||
	    (strcmp (msg, "parse error") == 0)  ||
	    (strcmp (msg, "syntax error") == 0)) {
	    if (in_construct()) {
		strcpy (err_msg, "");
	    } else {
		strcpy (err_msg, "was expecting '('");
	    }
	} else {
	    sprintf (err_msg, "%s", msg);
	}

	if (str[0] != '\0') {
	    sprintf (near_msg, " at '%s'", str);
	} else {
	    near_msg[0] = '\0';
	}

	rul__msg_cmp_print_w_line (
		CMP_SYNTAXERR, SL_line_number, err_msg, near_msg, "");
}




/************************************
**                                 **
**  RUL__PARSER_GET_CONSTRUCT_STR  **
**                                 **
************************************/

char *rul__parser_get_construct_str (void)
{
	static char in_msg[RUL_C_MAX_SYMBOL_SIZE*2+25];
	char *con_name, *con_type_str;
	Ast_Node_Type con_type;

	con_type = get_construct_type ();
	con_name = get_construct_name ();
	in_msg[0] = '\0';

	/*  Generate the current construct message fragment */
	if (con_type != AST__E_INVALID) {
	    con_type_str = construct_type_to_name (con_type);
	    if (con_type_str != NULL) {
		if (con_name[0] != '\0') {
		    /*  a named construct  */
		    sprintf (in_msg, " in %s %s", con_type_str, con_name);
		} else {
		    /*  an unnamed construct (e.g. on-empty)  */
		    sprintf (in_msg, " in %s", con_type_str);
		}
	    }
	}

	return (in_msg);
}
#line 3268 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 543 "../source/c_parser.y"
{ /* MRA */ set_in_construct (); }
break;
case 2:
#line 545 "../source/c_parser.y"
{
			    if (in_error()) {
				clear_error();
				YYABORT;
				}
			    else {
			        rul__main_set_cur_construct (yyvsp[-1].node);
			        YYACCEPT; /* Return after each construct */
				}
			    }
break;
case 3:
#line 556 "../source/c_parser.y"
{
			    yyclearin;
			    clear_error ();
			    yyclearin;
			    yyerrok;
			    YYABORT;
			    }
break;
case 20:
#line 582 "../source/c_parser.y"
{
			    yyclearin;
			    yyval.node = NULL;
			    }
break;
case 21:
#line 593 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_DECL_BLOCK, NULL); }
break;
case 22:
#line 596 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_DECL_BLOCK);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 23:
#line 608 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_ENTRY_BLOCK, yyvsp[0].node); }
break;
case 24:
#line 611 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ENTRY_BLOCK);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 25:
#line 619 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 26:
#line 622 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-3].node, yyvsp[-1].node);
			    }
break;
case 32:
#line 635 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ACTIVATES);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 33:
#line 642 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_USES);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 34:
#line 649 "../source/c_parser.y"
{
			    yyval.node = yyvsp[0].node;
			    }
break;
case 35:
#line 655 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_ON_ENTRY, NULL); }
break;
case 36:
#line 658 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ON_ENTRY);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 37:
#line 663 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ON_ENTRY);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    rul__msg_cmp_print (CMP_OBSSTARTUP, yyval.node);
			    }
break;
case 38:
#line 671 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_ON_EMPTY, NULL); }
break;
case 39:
#line 674 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ON_EMPTY);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 40:
#line 681 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_ON_EXIT, NULL); }
break;
case 41:
#line 684 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ON_EXIT);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 42:
#line 691 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_ON_EVERY, NULL); }
break;
case 43:
#line 694 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ON_EVERY);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 44:
#line 701 "../source/c_parser.y"
{
			    yyval.node = yyvsp[-1].node;
			    }
break;
case 45:
#line 705 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-3].node, yyvsp[-1].node);
			    }
break;
case 48:
#line 719 "../source/c_parser.y"
{ yyval.node = rul__ast_node (AST__E_AT_ACTION);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 49:
#line 725 "../source/c_parser.y"
{ yyval.node = NULL;
			      rul__msg_cmp_print_w_line (
					 CMP_NOACTION,
					 SL_line_number);
			    }
break;
case 50:
#line 731 "../source/c_parser.y"
{ yyval.node = yyvsp[0].node; }
break;
case 51:
#line 735 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 52:
#line 737 "../source/c_parser.y"
{ yyval.node = yyvsp[0].node; }
break;
case 54:
#line 742 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 55:
#line 746 "../source/c_parser.y"
{
			    yyclearin;
			    yyval.node = NULL;
			    }
break;
case 56:
#line 753 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 57:
#line 755 "../source/c_parser.y"
{
			    rul__msg_cmp_print_w_line (
			        CMP_UNTERMCON,
				SL_line_number);
			    rul__msg_print (CMP_UNTERMIGN);

			    rul__scan_unget_tokens (2);
			    yyclearin;
			    clear_error ();
			    yyerrok;
			    YYABORT;
			    }
break;
case 94:
#line 806 "../source/c_parser.y"
{
			    yyclearin;
			    yyval.node = NULL;
			    }
break;
case 95:
#line 813 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ADDSTATE_ACTION);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 96:
#line 820 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_AFTER_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 97:
#line 827 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_BIND_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 98:
#line 834 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_CALL_INHERITED);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 99:
#line 841 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_CLOSEFILE_ACTION);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 100:
#line 848 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_COPY_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 101:
#line 855 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_DEBUG_ACTION);
			    }
break;
case 102:
#line 861 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_DEFAULT_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 103:
#line 868 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_FOR_EACH_ACTION);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-3].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 104:
#line 875 "../source/c_parser.y"
{
			    Ast_Node if_then;

			    yyval.node = rul__ast_node (AST__E_IF_ACTION);
			    if_then = rul__ast_node (AST__E_IF_THEN);
			    rul__ast_attach_child (if_then, yyvsp[-1].node);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-3].node, if_then, yyvsp[0].node);
			    }
break;
case 105:
#line 886 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_MAKE_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 106:
#line 893 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_MODIFY_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 107:
#line 900 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPENFILE_ACTION);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 108:
#line 907 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_QUIT_ACTION);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 109:
#line 914 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 111:
#line 917 "../source/c_parser.y"
{ yyval.node = rul__ast_node (AST__E_FAILURE); }
break;
case 112:
#line 919 "../source/c_parser.y"
{ yyval.node = rul__ast_node (AST__E_SUCCESS); }
break;
case 113:
#line 923 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_REMOVE_ACTION);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 114:
#line 930 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_REMOVE_EVERY_ACTION);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 115:
#line 937 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RESTORESTATE_ACTION);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 116:
#line 944 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RETURN_ACTION);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 117:
#line 951 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SAVESTATE_ACTION);
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 118:
#line 958 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SPECIALIZE_ACTION);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 119:
#line 965 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_TRACE_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 120:
#line 972 "../source/c_parser.y"
{
			    Ast_Node while_do;

			    yyval.node = rul__ast_node (AST__E_WHILE_ACTION);
			    while_do = rul__ast_node (AST__E_WHILE_DO);
			    rul__ast_attach_child (while_do, yyvsp[0].node);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, while_do);
			    }
break;
case 121:
#line 983 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_WRITE_ACTION);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 122:
#line 990 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_ATTACH_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 123:
#line 997 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_COMMIT_ACTION);
			    }
break;
case 124:
#line 1003 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_DELETE_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 125:
#line 1010 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_DETACH_ACTION);
			    }
break;
case 126:
#line 1017 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_FETCH_EACH_ACTION);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-4].node, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 127:
#line 1024 "../source/c_parser.y"
{
		        yyval.node = rul__ast_node (AST__E_SQL_FETCH_AS_OBJECT_ACTION);
			rul__ast_attach_child (yyval.node, yyvsp[0].node);
			}
break;
case 128:
#line 1031 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_INSERT_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 129:
#line 1038 "../source/c_parser.y"
{
		     yyval.node = rul__ast_node (AST__E_SQL_INSERT_FROM_OBJECT_ACTION);
		     rul__ast_attach_child (yyval.node, yyvsp[0].node);
		     }
break;
case 130:
#line 1045 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_ROLLBACK_ACTION);
			    }
break;
case 131:
#line 1051 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_START_ACTION);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 132:
#line 1058 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_SQL_UPDATE_ACTION);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 133:
#line 1065 "../source/c_parser.y"
{
		     yyval.node = rul__ast_node (AST__E_SQL_UPDATE_FROM_OBJECT_ACTION);
		     rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
		     }
break;
case 134:
#line 1072 "../source/c_parser.y"
{ yyval.node = yyvsp[0].node; }
break;
case 135:
#line 1074 "../source/c_parser.y"
{
		            yyval.node = rul__ast_node (AST__E_SQL_PATHNAME);
		            rul__ast_attach_child (yyval.node, yyvsp[0].node);
		            }
break;
case 137:
#line 1082 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 142:
#line 1096 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 144:
#line 1101 "../source/c_parser.y"
{
		            yyval.node = rul__ast_node (AST__E_SQL_ACTIONS);
		            rul__ast_attach_child (yyval.node, yyvsp[0].node);
		            }
break;
case 145:
#line 1108 "../source/c_parser.y"
{
		            yyval.node = rul__ast_node (AST__E_SQL_RSE);
		            rul__ast_attach_child (yyval.node, yyvsp[0].node);
		            }
break;
case 146:
#line 1115 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 151:
#line 1125 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 152:
#line 1129 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 153:
#line 1133 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 154:
#line 1137 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 155:
#line 1141 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 156:
#line 1145 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 157:
#line 1149 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 158:
#line 1153 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 159:
#line 1157 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 160:
#line 1161 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 161:
#line 1165 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 162:
#line 1169 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 163:
#line 1173 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 164:
#line 1177 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 165:
#line 1181 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 166:
#line 1185 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 167:
#line 1189 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 168:
#line 1193 "../source/c_parser.y"
{ yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
				      rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 169:
#line 1199 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 170:
#line 1201 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 171:
#line 1207 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RHS_ACTION_TERM);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    rul__ast_attach_child (yyvsp[-2].node, yyvsp[-1].node);
			    }
break;
case 172:
#line 1213 "../source/c_parser.y"
{ yyclearin;  yyval.node = NULL; }
break;
case 175:
#line 1219 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 176:
#line 1221 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 177:
#line 1223 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 178:
#line 1225 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 179:
#line 1227 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 180:
#line 1229 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 181:
#line 1233 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 185:
#line 1244 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (AST__E_CATCH, yyvsp[0].node);}
break;
case 186:
#line 1246 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_CATCH);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 187:
#line 1253 "../source/c_parser.y"
{ yyval.node = yyvsp[-1].node; }
break;
case 189:
#line 1258 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_AND);
			    rul__ast_attach_child (yyval.node, yyvsp[-2].node);
			    rul__ast_append_sibling (yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 190:
#line 1264 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_OR);
			    rul__ast_attach_child (yyval.node, yyvsp[-2].node);
			    rul__ast_append_sibling (yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 191:
#line 1270 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_NOT);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 192:
#line 1277 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_COND_EXPR);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 193:
#line 1282 "../source/c_parser.y"
{
			    yyval.node = yyvsp[-1].node;
			    }
break;
case 194:
#line 1288 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 195:
#line 1290 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_IF_ELSE);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 219:
#line 1326 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_BTI_ACCEPT_ATOM);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 220:
#line 1333 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_ACCEPTLINE_COMPOUND);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 221:
#line 1340 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 222:
#line 1342 "../source/c_parser.y"
{ yyval.node = rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node); }
break;
case 223:
#line 1346 "../source/c_parser.y"
{
			    yyval.node = compound_is_a_constant (yyvsp[0].node);
			    if (yyval.node == NULL) {
			        yyval.node = rul__ast_node (AST__E_BTI_COMPOUND);
			        rul__ast_attach_child (yyval.node, yyvsp[0].node);
			        }
			    }
break;
case 224:
#line 1356 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_BTI_CONCAT);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 225:
#line 1363 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_CRLF);
			    }
break;
case 226:
#line 1369 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_EVERY);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 227:
#line 1376 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_FLOAT);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 228:
#line 1383 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_GENATOM);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 229:
#line 1390 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_GENINT);
			    }
break;
case 230:
#line 1396 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_GET);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 231:
#line 1403 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_INTEGER);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 232:
#line 1410 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_IS_OPEN);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 233:
#line 1417 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_LENGTH);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 234:
#line 1424 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_BTI_MAX);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 235:
#line 1431 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_BTI_MIN);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 236:
#line 1438 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_NTH);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 237:
#line 1445 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_POSITION);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 238:
#line 1452 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_RJUST);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 239:
#line 1459 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_SUBCOMPOUND);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 240:
#line 1466 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_SUBSYMBOL);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 241:
#line 1473 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_SYMBOL);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 242:
#line 1480 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_SYMBOL_LENGTH);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 243:
#line 1487 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_BTI_TABTO);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 244:
#line 1499 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_RULE_BLOCK, yyvsp[0].node); }
break;
case 245:
#line 1502 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RULE_BLOCK);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 246:
#line 1509 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 247:
#line 1512 "../source/c_parser.y"
{
			yyval.node = rul__ast_append_opt_sibling (yyvsp[-3].node, yyvsp[-1].node);
			}
break;
case 250:
#line 1522 "../source/c_parser.y"
{
			yyval.node = rul__ast_node (AST__E_STRATEGY);
			rul__ast_attach_long_value (yyval.node, AST__E_TYPE_STRATEGY,
						    CS__C_LEX);
			}
break;
case 251:
#line 1528 "../source/c_parser.y"
{ 
			yyval.node = rul__ast_node (AST__E_STRATEGY);
			rul__ast_attach_long_value (yyval.node, AST__E_TYPE_STRATEGY,
						    CS__C_MEA);
			}
break;
case 252:
#line 1540 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_END_BLOCK, NULL); }
break;
case 253:
#line 1543 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_END_BLOCK);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 254:
#line 1555 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RULE_GROUP);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    set_cur_construct (AST__E_RULE_GROUP, yyvsp[0].node);
			    }
break;
case 255:
#line 1563 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_END_GROUP);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    set_cur_construct (AST__E_END_GROUP, NULL);
			    }
break;
case 256:
#line 1577 "../source/c_parser.y"
{/*MRA*/ set_cur_construct (AST__E_OBJ_CLASS, yyvsp[0].node);}
break;
case 257:
#line 1580 "../source/c_parser.y"
{
			    Ast_Node attrs;

			    yyval.node = rul__ast_node (AST__E_OBJ_CLASS);
			    attrs = rul__ast_node (AST__E_OBJ_ATTRS);
			    rul__ast_attach_child (attrs, yyvsp[0].node);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-3].node, yyvsp[-1].node, attrs);
			    }
break;
case 258:
#line 1592 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 259:
#line 1594 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OBJ_CLASS_INH);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 260:
#line 1602 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 261:
#line 1604 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 262:
#line 1611 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ATTRIBUTE);
			    rul__ast_attach_children (yyval.node, 4, yyvsp[-3].node, yyvsp[-2].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 264:
#line 1622 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 265:
#line 1624 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ATTR_COMPOUND);
			    }
break;
case 266:
#line 1631 "../source/c_parser.y"
{ yyval.node = NULL;  }
break;
case 267:
#line 1633 "../source/c_parser.y"
{ yyval.node = NULL;  }
break;
case 268:
#line 1635 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
					AST__E_ATTR_DOMAIN,
				    	rul__mol_make_symbol ("INSTANCE"));
			    rul__ast_attach_children (yyval.node, 1, yyvsp[0].node);
			    }
break;
case 269:
#line 1642 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
					AST__E_ATTR_DOMAIN,
				    	rul__mol_make_symbol ("INTEGER"));
			    }
break;
case 270:
#line 1648 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
					AST__E_ATTR_DOMAIN,
				    	rul__mol_make_symbol ("FLOAT"));
			    }
break;
case 271:
#line 1654 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
					AST__E_ATTR_DOMAIN,
				    	rul__mol_make_symbol ("OPAQUE"));
			    }
break;
case 272:
#line 1660 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
					AST__E_ATTR_DOMAIN,
				    	rul__mol_make_symbol ("SYMBOL"));
			    }
break;
case 273:
#line 1669 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 274:
#line 1671 "../source/c_parser.y"
{
			    rul__ast_reset_node_type (yyvsp[0].node, AST__E_ATTR_CLASS);
			    yyval.node = yyvsp[0].node;
			    }
break;
case 275:
#line 1679 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 276:
#line 1681 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 277:
#line 1687 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ATTR_DEFAULT);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 278:
#line 1692 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ATTR_COMPOUND_DEFAULT);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 279:
#line 1697 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ATTR_COMPOUND_FILL);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 280:
#line 1710 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_GENERIC_METHOD, yyvsp[0].node); }
break;
case 281:
#line 1714 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_GENERIC_METHOD);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-3].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 282:
#line 1724 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ACCEPTS_DECL);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[-1].node);
			    }
break;
case 283:
#line 1732 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 284:
#line 1734 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RETURNS_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 285:
#line 1742 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_METHOD_WHEN);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-3].node, yyvsp[0].node);
			    }
break;
case 286:
#line 1754 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_METHOD, yyvsp[0].node); }
break;
case 287:
#line 1758 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_METHOD);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-3].node, yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 288:
#line 1768 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ACCEPTS_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[-2].node);
			    rul__ast_append_sibling (yyvsp[-2].node, yyvsp[-1].node);
			    }
break;
case 289:
#line 1777 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_METHOD_WHEN);
			    rul__ast_attach_child (yyval.node, yyvsp[-4].node);
			    rul__ast_append_sibling (yyvsp[-4].node, yyvsp[0].node);
			    }
break;
case 290:
#line 1786 "../source/c_parser.y"
{
			      yyval.node = rul__ast_node (AST__E_METHOD_PARAM);
			      rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			      rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 291:
#line 1795 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 292:
#line 1797 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 293:
#line 1804 "../source/c_parser.y"
{
			    if (yyvsp[-2].node != NULL) {
			        yyval.node = rul__ast_node (AST__E_METHOD_RHS);
			        rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			        }
			    }
break;
case 294:
#line 1812 "../source/c_parser.y"
{
			    Ast_Node rhs;
			    yyval.node = rul__ast_node (AST__E_RETURNS_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[-2].node);

			    rhs = rul__ast_node (AST__E_METHOD_RHS);
			    rul__ast_append_sibling (yyval.node, rhs);
			    rul__ast_attach_child (rhs, yyvsp[0].node);
			    }
break;
case 295:
#line 1825 "../source/c_parser.y"
{
			      yyval.node = rul__ast_node (AST__E_METHOD_PARAM);
			      rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			      rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 296:
#line 1834 "../source/c_parser.y"
{
			      if (yyvsp[-1].node == NULL)
				yyval.node = yyvsp[0].node;
			      else
				yyval.node = rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 297:
#line 1849 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (
						AST__E_EXT_RT_DECL, yyvsp[0].node); }
break;
case 298:
#line 1852 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_EXT_RT_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[-2].node);
			    rul__ast_append_sibling (yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 299:
#line 1861 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 300:
#line 1863 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_sibling (yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 304:
#line 1876 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ALIAS_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 305:
#line 1884 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ACCEPTS_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 306:
#line 1893 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_RETURNS_DECL);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 307:
#line 1904 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ACCEPTS_PARAM);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[-2].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[-3].node);
			    }
break;
case 308:
#line 1915 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 309:
#line 1917 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 310:
#line 1927 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_sibling (yyvsp[-1].node, yyvsp[-2].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[-3].node);
			    }
break;
case 311:
#line 1936 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 313:
#line 1942 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 314:
#line 1944 "../source/c_parser.y"
{
                            yyval.node = yyvsp[-1].node;
			    }
break;
case 315:
#line 1951 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_long);
			    }
break;
case 316:
#line 1955 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_short);
			    }
break;
case 317:
#line 1959 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_byte);
			    }
break;
case 318:
#line 1963 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_uns_long);
			    }
break;
case 319:
#line 1967 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_uns_short);
			    }
break;
case 320:
#line 1971 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_uns_byte);
			    }
break;
case 321:
#line 1975 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_float);
			    }
break;
case 322:
#line 1979 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_double);
			    }
break;
case 323:
#line 1983 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_asciz);
			    }
break;
case 324:
#line 1987 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_ascid);
			    }
break;
case 325:
#line 1991 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_void_ptr);
			    }
break;
case 326:
#line 1995 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_type_node (ext_type_atom);
			    }
break;
case 327:
#line 2002 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 328:
#line 2004 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_mech_node (ext_mech_ref_ro);
			    }
break;
case 329:
#line 2008 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_mech_node (ext_mech_ref_rw);
			    }
break;
case 330:
#line 2012 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_mech_node (ext_mech_value);
			    }
break;
case 331:
#line 2019 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 332:
#line 2021 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_mech_node (ext_mech_ref_ro);
			    }
break;
case 333:
#line 2025 "../source/c_parser.y"
{
			    yyval.node = rul__ast_ext_mech_node (ext_mech_value);
			    }
break;
case 334:
#line 2032 "../source/c_parser.y"
{
			    yyval.node = rul__ast_cardinality_node (-1);
			    }
break;
case 335:
#line 2036 "../source/c_parser.y"
{
			    yyval.node = rul__ast_cardinality_node (yylval.tok.ival);
			    }
break;
case 336:
#line 2040 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_EXT_LEN);
			    rul__ast_attach_value (yyval.node, AST__E_TYPE_MOL,
						   rul__ast_get_value (yyvsp[0].node));
			    rul__mol_incr_uses (rul__ast_get_value (yyvsp[0].node));
			    rul__ast_free (yyvsp[0].node);
			    }
break;
case 337:
#line 2057 "../source/c_parser.y"
{ /* MRA */ set_cur_construct (AST__E_RULE, yyvsp[0].node);}
break;
case 338:
#line 2059 "../source/c_parser.y"
{
			    Ast_Node lhs, ce1, rhs;

			    yyval.node = rul__ast_node (AST__E_RULE);
			    lhs = rul__ast_node (AST__E_RULE_LHS);
			    ce1 = rul__ast_node (AST__E_POS_CE);
			    rhs = rul__ast_node (AST__E_RULE_RHS);
			    rul__ast_attach_children (yyval.node, 3, yyvsp[-5].node, lhs, rhs);
			    rul__ast_attach_children (lhs, 2, ce1, yyvsp[-2].node);
			    rul__ast_attach_child (ce1, yyvsp[-3].node);
			    rul__ast_attach_child (rhs, yyvsp[0].node);
			    }
break;
case 339:
#line 2074 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 340:
#line 2076 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 341:
#line 2084 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 342:
#line 2086 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 345:
#line 2096 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_POS_CE);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 346:
#line 2110 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_NEG_CE);
                            rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 347:
#line 2137 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_CE);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[-1].node);
			    }
break;
case 348:
#line 2142 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_CE);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[-1].node);

			    rul__msg_cmp_print_w_line (
				CMP_UNTERMCE,
				SL_line_number);

			    rul__scan_unget_tokens (1);
			    }
break;
case 349:
#line 2153 "../source/c_parser.y"
{
			    yyclearin;
			    yyval.node = NULL;
			    }
break;
case 350:
#line 2160 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 351:
#line 2162 "../source/c_parser.y"
{ yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node); }
break;
case 352:
#line 2166 "../source/c_parser.y"
{
			    Ast_Node attr;

			    attr = rul__ast_node (AST__E_ATTR_EXPR);
			    rul__ast_attach_children (attr, 2, yyvsp[-2].node, yyvsp[-1].node);
			    yyval.node = rul__ast_node (AST__E_ATTR_TEST);
			    rul__ast_attach_children (yyval.node, 2, attr, yyvsp[0].node);
			    }
break;
case 353:
#line 2175 "../source/c_parser.y"
{ yyclearin;  yyval.node = NULL; }
break;
case 354:
#line 2179 "../source/c_parser.y"
{ yyval.node = NULL; }
break;
case 355:
#line 2181 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ATTR_INDEX);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 357:
#line 2189 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_DOLLAR_LAST);
			    }
break;
case 360:
#line 2197 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 361:
#line 2199 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 362:
#line 2201 "../source/c_parser.y"
{ yyval.node = yyvsp[-1].node; }
break;
case 363:
#line 2203 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_DOLLAR_LAST);
			    }
break;
case 365:
#line 2210 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 366:
#line 2214 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 368:
#line 2221 "../source/c_parser.y"
{
			    Ast_Node list_node;

			    yyval.node = rul__ast_pred_type_node (PRED__E_EQ);

			    list_node = rul__ast_node (AST__E_VALUE_DISJ);
			    rul__ast_attach_child (yyval.node, list_node);
			    rul__ast_attach_child (list_node, yyvsp[-1].node);
			    }
break;
case 369:
#line 2231 "../source/c_parser.y"
{
			    Ast_Node opt_pred;

			    opt_pred = rul__ast_get_child (yyvsp[-1].node);
			    if (opt_pred)
			        rul__ast_append_sibling (opt_pred, yyvsp[0].node);
			    else
			        rul__ast_attach_child (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 370:
#line 2241 "../source/c_parser.y"
{
			    yyval.node = rul__ast_pred_type_node (PRED__E_EQ);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 372:
#line 2249 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_PLUS);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 373:
#line 2254 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_MINUS);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 374:
#line 2259 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_TIMES);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 375:
#line 2264 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_DIVIDE);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 376:
#line 2269 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_MODULUS);
			    rul__ast_attach_children (yyval.node, 2, yyvsp[-2].node, yyvsp[0].node);
			    }
break;
case 377:
#line 2274 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_OPR_UMINUS);
			    rul__ast_attach_child (yyval.node, yyvsp[0].node);
			    }
break;
case 381:
#line 2284 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 382:
#line 2286 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 383:
#line 2288 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ARITH_EXPR);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 384:
#line 2293 "../source/c_parser.y"
{
			    yyclearin;
			    yyval.node = NULL;
			    }
break;
case 385:
#line 2301 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 386:
#line 2305 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 387:
#line 2311 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 390:
#line 2317 "../source/c_parser.y"
{
                            yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 391:
#line 2323 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 392:
#line 2325 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 393:
#line 2327 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 394:
#line 2329 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 395:
#line 2331 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 396:
#line 2333 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 397:
#line 2335 "../source/c_parser.y"
{ yyval.node = rul__ast_str_node (yylval.tok.sval); }
break;
case 398:
#line 2343 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 400:
#line 2350 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node(AST__E_EXT_RT_CALL);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 402:
#line 2359 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 403:
#line 2365 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 404:
#line 2367 "../source/c_parser.y"
{  yyval.node = yyvsp[0].node;  }
break;
case 405:
#line 2371 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 406:
#line 2373 "../source/c_parser.y"
{ yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node); }
break;
case 408:
#line 2379 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 411:
#line 2385 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 412:
#line 2387 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 413:
#line 2389 "../source/c_parser.y"
{
			    yyval.node = rul__ast_node (AST__E_ARITH_EXPR);
			    rul__ast_attach_child (yyval.node, yyvsp[-1].node);
			    }
break;
case 414:
#line 2394 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 415:
#line 2396 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 416:
#line 2398 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 417:
#line 2400 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 418:
#line 2402 "../source/c_parser.y"
{  yyval.node = yyvsp[-1].node;  }
break;
case 424:
#line 2413 "../source/c_parser.y"
{
			    yyval.node = rul__ast_append_opt_sibling (yyvsp[-1].node, yyvsp[0].node);
			    }
break;
case 426:
#line 2420 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 429:
#line 2426 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 430:
#line 2430 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 431:
#line 2434 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 432:
#line 2438 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 434:
#line 2445 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 435:
#line 2449 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 436:
#line 2453 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 439:
#line 2468 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 440:
#line 2475 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 441:
#line 2477 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 442:
#line 2479 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 443:
#line 2481 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 444:
#line 2483 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 445:
#line 2485 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 446:
#line 2487 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 447:
#line 2489 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 448:
#line 2491 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 449:
#line 2493 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 450:
#line 2495 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 451:
#line 2497 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 452:
#line 2499 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 453:
#line 2501 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 454:
#line 2503 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 455:
#line 2505 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 456:
#line 2507 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 457:
#line 2512 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 458:
#line 2514 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 459:
#line 2516 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 460:
#line 2518 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 461:
#line 2520 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 462:
#line 2522 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 463:
#line 2524 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 464:
#line 2526 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 465:
#line 2528 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 466:
#line 2530 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 467:
#line 2532 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 468:
#line 2534 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 469:
#line 2536 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 470:
#line 2538 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 471:
#line 2540 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 472:
#line 2542 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 473:
#line 2544 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 474:
#line 2546 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 475:
#line 2548 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 476:
#line 2550 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 477:
#line 2552 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 478:
#line 2554 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 479:
#line 2556 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 480:
#line 2558 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 481:
#line 2560 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 482:
#line 2562 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 483:
#line 2564 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 484:
#line 2566 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 485:
#line 2579 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 486:
#line 2581 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 487:
#line 2583 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 488:
#line 2585 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 489:
#line 2587 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 490:
#line 2589 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 491:
#line 2591 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 492:
#line 2593 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 493:
#line 2595 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 494:
#line 2597 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 495:
#line 2599 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 496:
#line 2601 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 497:
#line 2603 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 498:
#line 2605 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 499:
#line 2607 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 500:
#line 2609 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 501:
#line 2611 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 502:
#line 2613 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 503:
#line 2615 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 504:
#line 2617 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 505:
#line 2619 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 506:
#line 2621 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 507:
#line 2623 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 508:
#line 2625 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 509:
#line 2627 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 510:
#line 2629 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 511:
#line 2631 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 512:
#line 2633 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 513:
#line 2635 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 514:
#line 2637 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 515:
#line 2639 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 516:
#line 2641 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 517:
#line 2643 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 518:
#line 2645 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 519:
#line 2647 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 520:
#line 2649 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 521:
#line 2651 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 522:
#line 2653 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 523:
#line 2655 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 524:
#line 2657 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 525:
#line 2659 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 526:
#line 2661 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 527:
#line 2663 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 528:
#line 2665 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 529:
#line 2669 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 530:
#line 2671 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 531:
#line 2673 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 532:
#line 2675 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 533:
#line 2677 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 534:
#line 2679 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 535:
#line 2681 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 536:
#line 2683 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 537:
#line 2685 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 538:
#line 2687 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 539:
#line 2689 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 540:
#line 2691 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 541:
#line 2693 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 542:
#line 2695 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 543:
#line 2697 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 544:
#line 2699 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 545:
#line 2701 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 546:
#line 2703 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 547:
#line 2705 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 548:
#line 2707 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 549:
#line 2709 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 550:
#line 2711 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 551:
#line 2713 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 552:
#line 2715 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 553:
#line 2717 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 554:
#line 2719 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 555:
#line 2721 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 556:
#line 2723 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 557:
#line 2725 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 558:
#line 2727 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 559:
#line 2729 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 560:
#line 2731 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 561:
#line 2733 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 562:
#line 2735 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 563:
#line 2737 "../source/c_parser.y"
{  yyval.node = NULL;  }
break;
case 564:
#line 2741 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 565:
#line 2743 "../source/c_parser.y"
{  yyval.node = NULL; }
break;
case 566:
#line 2747 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_EQ); }
break;
case 570:
#line 2756 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_SAME_TYPE); }
break;
case 571:
#line 2758 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_DIFF_TYPE); }
break;
case 572:
#line 2760 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_EQUAL); }
break;
case 573:
#line 2762 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_EQ); }
break;
case 574:
#line 2764 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_APPROX_EQUAL); }
break;
case 575:
#line 2766 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_NOT_APPROX_EQUAL);}
break;
case 576:
#line 2768 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_NOT_EQ); }
break;
case 577:
#line 2770 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_NOT_EQUAL); }
break;
case 578:
#line 2772 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_GREATER); }
break;
case 579:
#line 2774 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_GREATER_EQUAL); }
break;
case 580:
#line 2776 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LESS); }
break;
case 581:
#line 2778 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LESS_EQUAL); }
break;
case 582:
#line 2782 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LENGTH_EQUAL); }
break;
case 583:
#line 2784 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LENGTH_NOT_EQUAL); }
break;
case 584:
#line 2786 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LENGTH_GREATER); }
break;
case 585:
#line 2788 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LENGTH_GREATER_EQUAL); }
break;
case 586:
#line 2790 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LENGTH_LESS); }
break;
case 587:
#line 2792 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_LENGTH_LESS_EQUAL); }
break;
case 588:
#line 2794 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_CONTAINS); }
break;
case 589:
#line 2796 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_DOES_NOT_CONTAIN); }
break;
case 590:
#line 2798 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_CONTAINS);
	      rul__ast_attach_child (yyval.node, yyvsp[0].node); }
break;
case 591:
#line 2801 "../source/c_parser.y"
{ yyval.node = rul__ast_pred_type_node (PRED__E_DOES_NOT_CONTAIN);
	      rul__ast_attach_child (yyval.node, yyvsp[0].node); }
break;
case 592:
#line 2804 "../source/c_parser.y"
{ yyval.node = yyvsp[-1].node;
	      rul__ast_attach_child (yyval.node,
			     rul__ast_pred_type_node (PRED__E_CONTAINS)); }
break;
case 593:
#line 2808 "../source/c_parser.y"
{ yyval.node = yyvsp[-1].node;
	      rul__ast_attach_child (yyval.node,
		     rul__ast_pred_type_node (PRED__E_DOES_NOT_CONTAIN)); }
break;
case 594:
#line 2835 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (AST__E_CONSTANT,
						    comp_const_val);
			    }
break;
case 595:
#line 2842 "../source/c_parser.y"
{
			    comp_const_index = 0;
			    comp_const_val = rul__mol_make_comp(0);
			    yyval.node = NULL;
			    }
break;
case 596:
#line 2848 "../source/c_parser.y"
{
			    comp_const_val =
				rul__mol_set_comp_nth(comp_const_val,
						      ++comp_const_index,
						      rul__ast_get_value(yyvsp[0].node),
						      NULL);
			    rul__ast_free(yyvsp[0].node);
			    yyval.node = NULL;
			    }
break;
case 597:
#line 2860 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_CONSTANT,
				    rul__mol_make_int_atom (yylval.tok.ival));
			    }
break;
case 598:
#line 2868 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_CONSTANT,
				    rul__mol_make_dbl_atom (yylval.tok.fval));
			    }
break;
case 599:
#line 2876 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_VARIABLE,
				    rul__mol_make_symbol (
					upcase_in_place (yylval.tok.sval)));
			    }
break;
case 600:
#line 2885 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_QUOTED_VAR,
				    rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 601:
#line 2893 "../source/c_parser.y"
{
			    yyval.node = rul__ast_str_node (yylval.tok.sval);
			    }
break;
case 602:
#line 2899 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_CONSTANT,
				    rul__mol_make_symbol (yylval.tok.sval));
			    }
break;
case 603:
#line 2907 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_CONSTANT, rul__mol_opaque_null());
/* SB: Don't know reason for this !
**			    if (yylval.tok.ival != 0)
**				{
**				rul__msg_cmp_print_w_line (
**					CMP_INVOPAQUE, SL_line_number);
**			    	}
*/
			    }
break;
case 604:
#line 2921 "../source/c_parser.y"
{
			    yyval.node = rul__ast_mol_node (
				    AST__E_CONSTANT,
				    rul__mol_instance_id_zero ());
			    if (yylval.tok.ival != 0)
				{
				rul__msg_cmp_print_w_line (
					CMP_INVINSTID, SL_line_number);
			    	}
			    }
break;
#line 6007 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
